// PAQUETE
package API.Interfaces_RMI;

// IMPORTACIONES
import API.Excepciones.DataException;
import API.Tablas.Acceso_Sistema;
import API.Tablas.Cuenta;
import java.rmi.*;
import java.sql.SQLException;
import java.sql.ResultSet;



/** INTERFAZ ACCESO_SISTEMA_I:  Interfaz que establece los metodos a implementar en el uso de la tabla Acceso_Sistema
 *
 * @author  Napal Basterrica, Hector
 * @version 1.0
 *
 */
public interface Acceso_Sistema_I extends Remote
{
	// METODOS -------------------------------------------------------------
	// OBTENCION Y ESTABLECIMIENTO DE PARAMETROS
        // getCuenta: Metodo que obtiene el valor del atributo Cuenta
	public Cuenta getCuenta()                                               throws RemoteException;
        // setCuenta: Metodo que establece el valor del atributo Cuenta
	public void setCuenta(Cuenta Cuenta)                                    throws DataException, RemoteException;

        // DML
        // insertAccesoSistemaBD: Metodo que inserta el Acceso_Sistema en la BD
        public int insertAccesoSistemaBD()                                      throws SQLException, RemoteException;
        // updateAccesoSistemaBD: Metodo que actualiza el Acceso_Sistema en la BD
        public int updateAccesoSistemaBD(Acceso_Sistema Acceso_Sistema)         throws DataException, SQLException, RemoteException;
        // removeAccesiSistemaBD: Metodo que borra un Acceso_Sistema de la BD
        public int removeAccesoSistemaBD()                                      throws SQLException, RemoteException;

        // FUNCIONALIDADES
        // primerVigilante: Metodo que denota si solo se dispone de un vigilante accedido en el sistema en el dia de hoy
        public boolean primerVigilante()                                        throws SQLException, RemoteException;
        // obtenerAccesosSistema: Metodo que devuelve los datos de los accesos realizados en el sistema bajo unas condiciones dadas
        public ResultSet obtenerAccesosSistema(String Fecha_Inic, String Fecha_Fin, String Hora_Inic, String Hora_Fin, String Filtro)   throws SQLException, RemoteException;
}