// PAQUETE
package API.Interfaces_RMI;

// IMPORTACIONES
import API.Excepciones.DataException;
import API.Tablas.Cargo;
import java.rmi.*;
import java.sql.ResultSet;
import java.sql.SQLException;



/** INTERFAZ CARGO_I:  Interfaz que establece los metodos a implementar en el uso de la tabla Cargo
 *
 * @author  Napal Basterrica, Hector
 * @version 1.0
 *
 */
public interface Cargo_I extends Remote
{
	// METODOS -------------------------------------------------------------
	// OBTENCION Y ESTABLECIMIENTO DE PARAMETROS
        // getCodCargo: Metodo que obtiene el valor del atributo Cod_Cargo
	public String getCodCargo()                         throws RemoteException;
        // setCodCargo: Metodo que establece el valor del atributo Cod_Cargo
	public void setCodCargo(String Cod_Cargo)           throws DataException, RemoteException;
        // getDescripcion: Metodo que obtiene el valor del atributo Descripcion
	public String getDescripcion()                      throws RemoteException;
        // setDescripcion: Metodo que establece el valor del atributo Descripcion
	public void setDescripcion(String Descripcion)      throws DataException, RemoteException;

        // DML
        // insertCargoBD: Metodo que inserta el Cargo en la BD
        public int insertCargoBD()                          throws SQLException, RemoteException;
        // updateCargoBD: Metodo que actualiza el Cargo en la BD
        public int updateCargoBD(Cargo Cargo)               throws DataException, SQLException, RemoteException;
        // removeCargoBD: Metodo que borra un Cargo de la BD
        public int removeCargoBD()                          throws SQLException, RemoteException;


        // FUNCIONALIDAD
        // obtenerCargos: Metodo que devuelve los datos de los cargos existentes en el sistema
        public ResultSet obtenerCargos()                    throws SQLException, RemoteException;
        // obtenerCodCargo: Metodo que obtiene el codigo del cargo dada su descripcion
        public String obtenerCodCargo(String Descripcion)   throws SQLException, RemoteException;
        // obtenerDescripCargos: Metodo que devuelve las descripciones de los cargos existentes en el sistema
        public ResultSet obtenerDescripCargos()             throws SQLException, RemoteException;
}