// PAQUETE
package API.Interfaces_RMI;

// IMPORTACIONES
import API.Excepciones.DataException;
import java.rmi.*;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.Properties;
import javax.mail.MessagingException;



/** INTERFAZ CARTERO_I:  Interfaz que establece los metodos a implementar en el uso de la clase Cartero
 *
 * @author  Napal Basterrica, Hector
 * @version 1.0
 *
 */
public interface Cartero_I extends Remote
{
	// OBTENCION Y ESTABLECIMIENTO DE PARAMETROS
        // getPropiedades: Metodo que obtiene el valor del atributo Propiedades
	public Properties getPropiedades()                                          throws RemoteException;
        // setPropiedades: Metodo que establece el valor del atributo Propiedades
	public void setPropiedades(Properties Propiedades)                          throws DataException, RemoteException;
        // getUsuario: Metodo que obtiene el valor del atributo Usuario
	public String getUsuario()                                                  throws RemoteException;
        // setUsuario: Metodo que establece el valor del atributo Usuario
	public void setUsuario(String Usuario)                                      throws DataException, RemoteException;
        // getPass: Metodo que obtiene el valor del atributo Pass
	public String getPass()                                                     throws RemoteException;
        // setPass: Metodo que establece el valor del atributo Pass
	public void setPass(String Pass)                                            throws DataException, RemoteException;

        // ENVIO DE CORREOS
        // enviarCorreo: Metodo que envia un correo con los datos y destinatarios proporcionados
        public void enviarCorreo(ArrayList Receptores, String Tema, String Texto)   throws MessagingException, RemoteException;
        // enviarCorreo: Metodo que envia un correo con los datos proporcionados
        public void enviarCorreo(String Emisor, ArrayList Receptores, String Tema, String Texto, String Codificacion,String Tipo)   throws MessagingException, RemoteException;
        // enviarCorreosRenovacionPersonal: Metodo que envia los correos de peticion de renovacion de personal
        public void enviarCorreosRenovacionPersonal(int Dias)                       throws DataException, SQLException, MessagingException, RemoteException;
        // enviarCorreosPrestamosPendientes: Metodo que envia a la persona un E-Mail con todo el material pendiente de devolucion
        public void enviarCorreosPrestamosPendientes(String DNI)                    throws DataException, SQLException, MessagingException, RemoteException;
        // enviarCorreosPrestamosPendientes: Metodo que envia correos a todas las personas que poseen prestamos desde hace Dias dias
        public void enviarCorreosPrestamosPendientes(int Dias)                      throws DataException, SQLException, MessagingException, RemoteException;
}