// PAQUETE
package API.Interfaces_RMI;

// IMPORTACIONES
import API.Excepciones.DataException;
import API.Tablas.Nivel;
import API.Tablas.Color;
import java.rmi.*;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.ArrayList;



/** INTERFAZ COLOR_I:  Interfaz que establece los metodos a implementar en el uso de la tabla Color
 *
 * @author  Napal Basterrica, Hector
 * @version 1.0
 *
 */
public interface Color_I extends Remote
{
	// METODOS -------------------------------------------------------------
	// OBTENCION Y ESTABLECIMIENTO DE PARAMETROS
        // getCodColor: Metodo que obtiene el valor del atributo CodColor
	public int getCodColor()                                        throws RemoteException;
        // setColor: Metodo que establece el valor del atributo Color
	public void setCodColor(int Cod_Color)                          throws DataException, RemoteException;
        // getNivel: Metodo que obtiene el valor del atributo Nivel
	public Nivel getNivel()                                         throws RemoteException;
        // setNivel: Metodo que establece el valor del atributo Nivel
	public void setNivel(Nivel Nivel)                               throws RemoteException;

        // DML
        // insertColorBD: Metodo que inserta el Color en la BD
        public int insertColorBD()                                      throws SQLException, RemoteException;
        // updateColorBD: Metodo que actualiza el Color en la BD
        public int updateColorBD(Color Color)                           throws DataException, SQLException, RemoteException;
        // darBajaColorBD: Metodo que da de baja el Color en la BD
        public int darBajaColorBD()                                     throws SQLException, RemoteException;
        // removeColorBD: Metodo que borra un Color en la BD
        public int removeColorBD()                                      throws SQLException, RemoteException;

        // FUNCIONALIDADES
        // obtenerCeldasColores: Metodo que devuelve las celdas de los colores
        public ResultSet obtenerCeldasColores()                         throws SQLException, RemoteException;
        // obtenerColores: Metodo que devuelve los colores de las colores existentes
        public ArrayList obtenerColores()                               throws SQLException, RemoteException;
        // colorPorDefecto: Metodo que devuelve el color por defecto
        public int colorPorDefecto()                                    throws SQLException, RemoteException;
        // colorPorDefecto: Metodo que devuelve el color por defecto que le corresponde a la persona proporcionada
        public int colorPorDefecto(String DNI )                         throws SQLException, RemoteException;
        // eliminarColores: Metodo que borra todos los colores mas antiguos de Dias dias
        public int eliminarColores(int Dias)                            throws SQLException, RemoteException;
        // disparadorInsert: Metodo que ejecuta el disparador sobre BEFORE INSERT ON Color
        public int disparadorInsert()                                   throws SQLException, RemoteException;
        // disparadorUpdate: Metodo que ejecuta el disparador sobre AFTER UPDATE ON Color
        public int disparadorUpdate()                                   throws SQLException, RemoteException;
        // disparadorRemove: Metodo que ejecuta el disparador sobre AFTER REMOVE ON Color
        public int disparadorRemove()                                   throws SQLException, RemoteException;
}