// PAQUETE
package API.Interfaces_RMI;

// IMPORTACIONES
import API.Excepciones.DataException;
import API.Tablas.T_Usuario;
import API.Tablas.Cuenta;
import API.Tablas.Personal;
import java.rmi.*;
import java.sql.ResultSet;
import java.sql.SQLException;



/** INTERFAZ CUENTA_I:  Interfaz que establece los metodos a implementar en el uso de la tabla Cuenta
 *
 * @author  Napal Basterrica, Hector
 * @version 1.0
 *
 */
public interface Cuenta_I extends Remote
{
	// METODOS -------------------------------------------------------------
	// OBTENCION Y ESTABLECIMIENTO DE PARAMETROS
        // getUsuario: Metodo que obtiene el valor del atributo Usuario
	public String getUsuario()                              throws RemoteException;
        // setUsuario: Metodo que establece el valor del atributo Usuario
	public void setUsuario(String Usuario)                  throws DataException, RemoteException;
        // getPass: Metodo que obtiene el valor del atributo Pass
	public String getPass()                                 throws RemoteException;
        // setPass: Metodo que establece el valor del atributo Pass
	public void setPass(String Pass)                        throws DataException, RemoteException;
        // getTipo: Metodo que obtiene el valor del atributo Tipo
	public T_Usuario getTipo()                              throws RemoteException;
        // setTipo: Metodo que establece el valor del atributo Tipo
	public void setTipo(T_Usuario Tipo)                     throws DataException, RemoteException;
        // getPersona: Metodo que obtiene el valor del atributo Persona
	public Personal getPersona()                            throws RemoteException;
        // setPersona: Metodo que establece el valor del atributo Persona
	public void setPersona(Personal Persona)                throws DataException, RemoteException;

        // DML
        // insertCuentaBD: Metodo que inserta la Cuenta en la BD
        public int insertCuentaBD()                             throws SQLException, RemoteException;
        // updateCuentaBD: Metodo que actualiza la Cuenta en la BD
        public int updateCuentaBD(Cuenta Cuenta)                throws DataException, SQLException, RemoteException;
        // removeCuentaBD: Metodo que borra una Cuenta de la BD
        public int removeCuentaBD()                             throws SQLException, RemoteException;

        // FUNCIONALIDADES
        // checkPass: Metodo que comprueba si el password pasado como parametro corresponde a la cuenta
        public String checkPass(String Pass)                    throws SQLException, RemoteException;
        // obtenerCuentas: Metodo que devuelve los datos de las cuentas existentes en el sistema
        public ResultSet obtenerCuentas()                       throws DataException, SQLException, RemoteException;
        // obtenerDNIsAdmAut: Metodo que devuelve los DNIs de todos los administradores y autorizadores
        public ResultSet obtenerDNIsAdmAut()                    throws DataException, SQLException, RemoteException;
}