// PAQUETE
package API.Interfaces_RMI;

// IMPORTACIONES
import API.Excepciones.DataException;
import API.Tablas.Llave;
import API.Tablas.T_Acceso;
import API.Tablas.Personal;
import API.Tablas.Residente;
import java.rmi.*;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.HashMap;



/** INTERFAZ DEPARTAMENTO_I:  Interfaz que establece los metodos a implementar en el uso de la tabla Departamento
 *
 * @author  Napal Basterrica, Hector
 * @version 1.0
 *
 */
public interface Departamento_I extends Remote
{
	// METODOS -------------------------------------------------------------
	// OBTENCION Y ESTABLECIMIENTO DE PARAMETROS
        // getCodDep: Metodo que obtiene el valor del atributo Cod_Dep
	public String getCodDep()                                                       throws RemoteException;
        // setCodDep: Metodo que establece el valor del atributo Cod_Dep
	public void setCodDep(String Cod_Dep)                                           throws DataException, RemoteException;
        // getNombre: Metodo que obtiene el valor del atributo Nombre
	public String getNombre()                                                       throws RemoteException;
        // setNombre: Metodo que establece el valor del atributo Nombre
	public void setNombre(String Nombre)                                            throws DataException, RemoteException;
        // getAcceso: Metodo que obtiene el valor del atributo Acceso
	public T_Acceso getAcceso()                                                     throws RemoteException;
        // setAcceso: Metodo que establece el valor del atributo Acceso
	public void setAcceso(T_Acceso Acceso)                                          throws RemoteException;
        // getPeriodicidad: Metodo que obtiene el valor del atributo Periodicidad
	public int getPeriodicidad()                                                    throws RemoteException;
        // setPeriodicidad: Metodo que establece el valor del atributo Periodicidad
	public void setPeriodicidad(int Periodicidad)                                   throws DataException, RemoteException;
        // getAutorizador: Metodo que obtiene el valor del atributo Autorizador
	public Residente getAutorizador()                                               throws RemoteException;
        // setAutorizador: Metodo que establece el valor del atributo Autorizador
	public void setAutorizador(Residente Autorizador)                               throws RemoteException;
        // getPersonal: Metodo que obtiene el valor del atributo Personal
	public HashMap<String,Personal> getPersonal()                           throws RemoteException;
        // setPersonal: Metodo que establece el valor del atributo Personal
	public void setPersonal(HashMap<String,Personal> Personal)              throws DataException, RemoteException;
        // addPersona: Metodo que añade una persona a las ya existentes
        public void addPersona(Personal Persona)                                throws DataException, RemoteException;
        // updatePersona: Metodo que modifica una persona existente
        public void updatePersona(Personal Pers_old, Personal Pers_new) throws DataException, RemoteException;
        // removePersona: Metodo que elimina una persona de las existentes
        public void removePersona(Personal Persona)                             throws DataException, RemoteException;
        // getPersona: Metodo que obtiene una persona de las existentes
        public Personal getPersona(String DNI)                                  throws DataException, RemoteException;
        // getLlaves: Metodo que obtiene el valor del atributo Llaves
	public HashMap<String,Llave> getLlaves()                                throws RemoteException;
        // setLlaves: Metodo que establece el valor del atributo Zonas
	public void setLlaves(HashMap<String,Llave> Llaves)                     throws RemoteException;
        // addLlave: Metodo que añade una llave a las ya existentes
        public void addLlave(Llave Llave)                                       throws DataException, RemoteException;
        // updateLlave: Metodo que actualiza una llave existente
        public void updateLlave(Llave Llave_old, Llave Llave_new)               throws DataException, RemoteException;
        // removeLlave: Metodo que elimina una llave de las existentes
        public void removeLlave(Llave Llave)                                    throws DataException, RemoteException;
        // getLlave: Metodo que obtiene una Llave de las existentes
        public Llave getLlave(String Key_Llave)                                 throws DataException, RemoteException;
        
        // FUNCIONALIDADES
        // obtenerDatosRenovacionPersonal: Metodo que obtiene los datos de todos los departamentos cuyo personal debe
        public ResultSet obtenerDatosRenovacionPersonal(int Dias)               throws SQLException, RemoteException;
        // eliminarDepartamentos: Metodo que borra todos los departamentos que no hayan actualizado su personals egun lo establecido
        public int eliminarDepartamentos()                                      throws SQLException, RemoteException;
}