// PAQUETE
package API.Interfaces_RMI;

// IMPORTACIONES
import API.Excepciones.DataException;
import java.rmi.*;
import java.sql.ResultSet;
import java.sql.SQLException;



/** INTERFAZ LLAVE_I:  Interfaz que establece los metodos a implementar en el uso de la tabla Llave
 *
 * @author  Napal Basterrica, Hector
 * @version 1.0
 *
 */
public interface Llave_I extends Remote
{
	// METODOS -------------------------------------------------------------
	// OBTENCION Y ESTABLECIMIENTO DE PARAMETROS
        // getNotas: Metodo que obtiene el valor del atributo Notas
	public String getNotas()                                                    throws RemoteException;
        // setNotas: Metodo que establece el valor del atributo Notas
	public void setNotas(String Notas)                                          throws DataException, RemoteException;

        // FUNCIONALIDADES
        // obtenerLlaves: Metodo que devuelve las llaves existentes en la BD
        public ResultSet obtenerLlaves()                                            throws SQLException, RemoteException;
        // obtenerLlaves: Metodo que devuelve las llaves prestables a una persona y que pasan un filtro dado
        public ResultSet obtenerLlaves(String DNI, String Entrada, String Filtro)   throws SQLException, RemoteException;
        // obtenerPrestamos: Metodo que devuelve los datos de todas las llaves que permanecen en prestamo
        public ResultSet obtenerPrestamos()                                         throws SQLException, RemoteException;
        // obtenerEmpDeps: Metodo que devuelve todos los departamentos que pueden pedir la llave en prestamo
        public ResultSet obtenerEmpDeps()                                           throws SQLException, RemoteException;
        // obtenerOcasional: Metodo que devuelve todo el personal ocasional que puede pedir la llave en prestamo
        public ResultSet obtenerOcasional()                                         throws SQLException, RemoteException;
        // obtenerEmpDepsResto: Metodo que devuelve todos los departamentos que no pueden pedir la llave en prestamo
        public ResultSet obtenerEmpDepsResto()                                      throws SQLException, RemoteException;
        // obtenerOcasResto: Metodo que devuelve todo el personal ocasional que no puede pedir la llave en prestamo
        public ResultSet obtenerOcasionalResto()                                    throws SQLException, RemoteException;
        // eliminarPrestables: Metodo que elimina cualquier permiso de prestamo de esta llave
        public int eliminarPrestables()                                             throws SQLException, RemoteException;
        // codigoPorDefecto: Metodo que devuelve el codigo de llave por defecto
        public int codigoPorDefecto()                                               throws SQLException, RemoteException;
        // eliminarLlaves: Metodo que borra todas las llaves mas antiguas de Dias dias
        public int eliminarLlaves(int Dias)                                         throws SQLException, RemoteException;
}