// PAQUETE
package API.Interfaces_RMI;

// IMPORTACIONES
import API.Excepciones.DataException;
import API.Tablas.Nivel;
import java.rmi.*;
import java.sql.ResultSet;
import java.sql.SQLException;



/** INTERFAZ NIVEL_I:  Interfaz que establece los metodos a implementar en el uso de la tabla Nivel
 *
 * @author  Napal Basterrica, Hector
 * @version 1.0
 *
 */
public interface Nivel_I extends Remote
{
	// METODOS -------------------------------------------------------------
	// OBTENCION Y ESTABLECIMIENTO DE PARAMETROS
        // getCodNiv: Metodo que obtiene el valor del atributo Cod_Niv
	public int getCodNiv()                                          throws RemoteException;
        // setCodNiv: Metodo que establece el valor del atributo Cod_Niv
	public void setCodNiv(int Nivel)                                throws DataException, RemoteException;
        // getDescripcion: Metodo que obtiene el valor del atributo Descripcion
	public String getDescripcion()                                  throws RemoteException;
        // setDescripcion: Metodo que establece el valor del atributo Descripcion
	public void setDescripcion(String Descripcion)                  throws DataException, RemoteException;

        // DML
        // insertNivelBD: Metodo que inserta el Nivel en la BD
        public int insertNivelBD()                                      throws SQLException, RemoteException;
        // updateNivelBD: Metodo que actualiza el Nivel en la BD
        public int updateNivelBD(Nivel Nivel)                           throws SQLException, RemoteException;
        // darBajaNivelBD: Metodo que da de baja el Nivel en la BD
        public int darBajaNivelBD()                                     throws SQLException, RemoteException;
        // removeNivelBD: Metodo que borra un Nivel en la BD
        public int removeNivelBD()                                      throws SQLException, RemoteException;

        // FUNCIONALIDADES
        // obtenerNiveles: Metodo que obtiene los niveles existentes
        public ResultSet obtenerNiveles()                               throws SQLException, RemoteException;
        // obtenerNivelesJCB: Metodo que obtiene los niveles existentes
        public ResultSet obtenerNivelesJCB()                            throws SQLException, RemoteException;
        // nivelMinimo: Metodo que devuelve el nivel minimo existente
        public int nivelMinimo()                                        throws SQLException, RemoteException;
        // nivelPorDefecto: Metodo que devuelve el nivel por defecto
        public int nivelPorDefecto()                                    throws SQLException, RemoteException;
        // eliminarNiveles: Metodo que borra todos los niveles mas antiguos de Dias dias
        public int eliminarNiveles(int Dias)                            throws SQLException, RemoteException;
        // disparadorInsert: Metodo que ejecuta el disparador sobre BEFORE INSERT ON Nivel
        public int disparadorInsert()                                   throws SQLException, RemoteException;
        // disparadorUpdate: Metodo que ejecuta el disparador sobre BEFORE UPDATE ON Nivel
        public int disparadorUpdate()                                   throws SQLException, RemoteException;
}