// PAQUETE
package API.Interfaces_RMI;

// IMPORTACIONES
import API.Excepciones.DataException;
import API.Tablas.Llave;
import API.Tablas.Ocasional;
import API.Tablas.T_Acceso;
import java.rmi.*;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.Calendar;
import java.util.HashMap;



/** INTERFAZ PERMISO_OCASIONAL_I:  Interfaz que establece los metodos a implementar en el uso de la tabla Permiso_Ocasional
 *
 * @author  Napal Basterrica, Hector
 * @version 1.0
 *
 */
public interface Ocasional_I extends Remote
{
	// METODOS -------------------------------------------------------------
	// OBTENCION Y ESTABLECIMIENTO DE PARAMETROS
        // getEmpresa: Metodo que obtiene el valor del atributo Empresa
	public String getEmpresa()                                                  throws RemoteException;
        // setEmpresa: Metodo que establece el valor del atributo Empresa
	public void setEmpresa(String Empresa)                                      throws DataException, RemoteException;
        // getAcceso: Metodo que obtiene el valor del atributo Acceso
	public T_Acceso getAcceso()                                                 throws RemoteException;
        // setAcceso: Metodo que establece el valor del atributo Acceso
	public void setAcceso(T_Acceso Acceso)                                      throws DataException, RemoteException;
        // getFCaducidad: Metodo que obtiene el valor del atributo F_Caducidad
	public Calendar getFCaducidad()                                             throws RemoteException;
        // setFCaducidad: Metodo que establece el valor del atributo F_Caducidad
	public void setFCaducidad(Calendar F_Caducidad)                             throws DataException, RemoteException;
        // getNotas: Metodo que obtiene el valor del atributo Notas
	public String getNotas()                                                    throws RemoteException;
        // setNotas: Metodo que establece el valor del atributo Notas
	public void setNotas(String Notas)                                          throws DataException, RemoteException;
        // getLlaves: Metodo que obtiene el valor del atributo Llaves
	public HashMap<String,Llave> getLlaves()                                    throws RemoteException;
        // setLlaves: Metodo que establece el valor del atributo Llaves
	public void setLlaves(HashMap<String,Llave> Llaves)                         throws RemoteException;
        // addLlave: Metodo que añade una llave a las ya existentes
        public void addLlave(Llave Llave)                                           throws DataException, RemoteException;
        // updateLlave: Metodo que actualiza una llave existente
        public void updateLlave(Llave Llave_old, Llave Llave_new)                   throws DataException, RemoteException;
        // removeLlave: Metodo que elimina una llave de las existentes
        public void removeLlave(Llave Llave)                                        throws DataException, RemoteException;
        // getLlave: Metodo que obtiene una Llave de las existentes
        public Llave getLlave(String Key_Llave)                                     throws DataException, RemoteException;

        // DML
        // insertLlaveBD: Metodo que inserta una Llave prestable a un Ocasional
        public int insertLlaveBD(Llave Llave)                                       throws DataException, SQLException, RemoteException;
        // updateLlaveBD: Metodo que actualiza una llave prestable al Ocasional
        public int updateLlaveBD(Llave Llave_old, Llave Llave_new)                  throws DataException, SQLException, RemoteException;
        // removeLlaveBD: Metodo que borra una llave de las prestables al Ocasional
        public int removeLlaveBD(Llave Llave)                                       throws DataException, SQLException, RemoteException;
        // insertLlavesBD: Metodo que inserta las Llaves prestables al Ocasional
        public int insertLlavesBD()                                                 throws DataException, SQLException, RemoteException;
        // updateLlavesBD: Metodo que actualiza las Llaves prestables al ocasional
        public int updateLlavesBD()                                                 throws DataException, SQLException, RemoteException;
        // removeLlavesBD: Metodo que borra las Llaves prestables al Ocasional
        public int removeLlavesBD()                                                 throws DataException, SQLException, RemoteException;
        // getLlavesBD: Metodo que obtiene todas las llaves prestables al personal
        public HashMap<String,Llave> getLlavesBD ()                                 throws DataException, SQLException, RemoteException;
        // insertOcasionalBD: Metodo que inserta el Ocasional en la BD
        public int insertOcasionalBD()                                              throws DataException, SQLException, RemoteException;
        // updateOcasionalBD: Metodo que actualiza el Ocasional en la BD
        public int updateOcasionalBD(Ocasional Ocasional)                           throws DataException, SQLException, RemoteException;
        // removeOcasionalBD: Metodo que borra un Ocasional de la BD
        public int removeOcasional()                                                throws SQLException, RemoteException;

        // FUNCIONALIDADES
        // obtenerEmpresas: Metodo que obtiene las empresas para las que trabaja una persona dada
        public ResultSet obtenerEmpresas(String DNI)                                throws SQLException, RemoteException;
        // obtenerOcasional: Metodo que devuelve todo el personal ocasional de la BD
        public ResultSet obtenerOcasional()                                         throws SQLException, RemoteException;
        // eliminarOcasional: Metodo que borra todo el personal ocasional cuya fecha de caducidad haya expirado
        public int eliminarOcasional()                                              throws SQLException,RemoteException;
        // obtenerLlaves: Metodo que obtiene todas las llaves prestables a una persona ocasional
        public ResultSet obtenerLlaves()                                            throws SQLException,RemoteException;
        // obtenerLsPorPrestarOcas: Metodo que obtiene todas las llaves que no son prestables a una persona ocasional y que pasan el filtro proporcionado
        public ResultSet obtenerLsPorPrestarOcas(String Filtro)                     throws SQLException,RemoteException;
}