// PAQUETE
package API.Interfaces_RMI;

// IMPORTACIONES
import API.Excepciones.DataException;
import API.Tablas.Vigilante;
import API.Tablas.Parte_Seguridad;
import java.rmi.*;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.ArrayList;



/** INTERFAZ PARTE_SEGURIDAD_I:  Interfaz que establece los metodos a implementar en el uso de la tabla Parte_Seguridad
 *
 * @author  Napal Basterrica, Hector
 * @version 1.0
 *
 */
public interface Parte_Seguridad_I extends Remote
{
	// METODOS -------------------------------------------------------------
	// OBTENCION Y ESTABLECIMIENTO DE PARAMETROS
        // getVigilante: Metodo que obtiene el valor del atributo Vigilante
	public Vigilante getVigilante()                                         throws RemoteException;
        // setVigilante: Metodo que establece el valor del atributo Vigilante
	public void setVigilante(Vigilante Vigilante)                           throws DataException, RemoteException;
        // getIncidencias: Metodo que obtiene el valor del atributo Incidencias
	public String getIncidencias()                                          throws RemoteException;
        // setIncidencias: Metodo que establece el valor del atributo Incidencias
	public void setIncidencias(String Incidencias)                          throws DataException, RemoteException;

        // DML
        // insertParteSeguridadBD: Metodo que inserta el Parte_Seguridad en la BD
        public int insertParteSeguridadBD()                                     throws SQLException, RemoteException;
        // updateParteSeguridadBD: Metodo que actualiza el Parte_Seguridad en la BD
        public int updateParteSeguridadBD(Parte_Seguridad Parte_Seguridad)      throws SQLException, RemoteException;
        // removeParteSeguridadBD: Metodo que borra un Parte_Seguridad en la BD
        public int removeParteSeguridadBD()                                     throws SQLException, RemoteException;

        
        // FUNCIONALIDADES
        // obtenerPartes: Metodo que devuelve los partes redactados entre Fecha_Inic y Fecha_Fin, entre
        // las horas Hora_Inic y Hora_Fin por unos vigilantes dados
        public ResultSet obtenerPartes(String Fecha_Inic, String Fecha_Fin, String Hora_Inic, String Hora_Fin, String Cod_Vig)  throws SQLException, RemoteException;
        // obtenerPartesEditables: Metodo que devuelve las fechas de todos aquellos partes que son editables por el usuario
        public ArrayList obtenerPartesEditables(String DNI)                     throws SQLException, RemoteException;
}