// PAQUETE
package API.Interfaces_RMI;

// IMPORTACIONES
import API.Excepciones.DataException;
import API.Tablas.Cargo;
import java.rmi.*;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.HashMap;



/** INTERFAZ PERIODICO_CONTACTO_I:  Interfaz que establece los metodos a implementar en el uso de la tabla Periodico_Contacto
 *
 * @author  Napal Basterrica, Hector
 * @version 1.0
 *
 */
public interface Periodico_Contacto_I extends Remote
{
	// METODOS -------------------------------------------------------------
	// OBTENCION Y ESTABLECIMIENTO DE PARAMETROS
        // getCargos: Metodo que obtiene el valor del atributo Cargos
	public HashMap<String,Cargo> getCargos()                  throws RemoteException;
        // setCargos: Metodo que establece el valor del atributo Cargos
	public void setCargos(HashMap<String,Cargo> Cargos)       throws RemoteException;
        // addCargo: Metodo que añade un Cargo a los ya existentes
        public void addCargo(Cargo Cargo)                           throws DataException, RemoteException;
        // updateCargo: Metodo que modifica un Cargo existente
        public void updateCargo(Cargo Cargo_old, Cargo Cargo_new)   throws DataException, RemoteException;
        // removeCargo: Metodo que elimina un Cargo de los existentes
        public void removeCargo(Cargo Cargo)                        throws DataException, RemoteException;
        
        // FUNCIONALIDADES
        // obtenerContactos: Metodo que devuelve todos los contactos de la BD
        public ResultSet obtenerContactos()                         throws SQLException, RemoteException;
        // actualizarFUA: Metodo que actualiza las fecha de ultima actualizacion de las que la persona es responsable de personal
        public void actualizarFUA()                                 throws SQLException, RemoteException;
}