// PAQUETE
package API.Interfaces_RMI;

// IMPORTACIONES
import API.Excepciones.DataException;
import API.Tablas.Personal;
import java.rmi.*;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.ArrayList;



/** INTERFAZ Personal_I:  Interfaz que establece los metodos a implementar en el uso de la tabla Personal
 *
 * @author  Napal Basterrica, Hector
 * @version 1.0
 *
 */
public interface Personal_I extends Remote
{
	// METODOS -------------------------------------------------------------
	// OBTENCION Y ESTABLECIMIENTO DE PARAMETROS
        // getDNI: Metodo que obtiene el valor del atributo DNI
	public String getDNI()                                                  throws RemoteException;
        // setDNI: Metodo que establece el valor del atributo DNI
	public void setDNI(String DNI)                                          throws DataException, RemoteException;
        // getApellido1: Metodo que obtiene el valor del atributo Apellido1
	public String getApellido1()                                            throws RemoteException;
        // setApellido1: Metodo que establece el valor del atributo Apellido1
	public void setApellido1(String Apellido1)                              throws DataException, RemoteException;
        // getApellido2: Metodo que obtiene el valor del atributo Apellido2
	public String getApellido2()                                            throws RemoteException;
        // setApellido2: Metodo que establece el valor del atributo Apellido2
	public void setApellido2(String Apellido2)                              throws DataException, RemoteException;
        // getNombre: Metodo que obtiene el valor del atributo Nombre
	public String getNombre()                                               throws RemoteException;
        // setNombre: Metodo que establece el valor del atributo Nombre
	public void setNombre(String Nombre)                                    throws DataException, RemoteException;
        // getInsertador: Metodo que obtiene el valor del atributo Insertador
	public Personal getInsertador()                                         throws RemoteException;
        // setInsertador: Metodo que establece el valor del atributo Insertador
	public void setInsertador(Personal Insertador)                          throws DataException, RemoteException;
        // getTelefonos: Metodo que obtiene el valor del atributo Telefonos
	public ArrayList<String> getTelefonos()                                 throws RemoteException;
        // setTelefonos: Metodo que establece el valor del atributo Telefonos
	public void setTelefonos(ArrayList<String> Telefonos)                   throws RemoteException;
        // addTelefono: Metodo que añade un telefono a los ya existentes
        public void addTelefono(String Telefono)                                throws DataException, RemoteException;
        // updateTelefono: Metodo que modifica un Telefono existente
        public void updateTelefono(String Telefono_old, String Telefono_new)    throws DataException, RemoteException;
        // removeTelefono: Metodo que elimina un telefono de los existentes
        public void removeTelefono(String Telefono)                             throws DataException, RemoteException;
        // getEmails: Metodo que obtiene el valor del atributo Emails
	public ArrayList<String> getEmails()                                    throws RemoteException;
        // setEmails: Metodo que establece el valor del atributo Emails
	public void setEmails(ArrayList<String> Emails)                         throws RemoteException;
        // addEmail: Metodo que añade un e-mail a los ya existentes
        public void addEmail(String Email)                                      throws DataException, RemoteException;
        // updateEmail: Metodo que modifica un Email existente
        public void updateEmail(String Email_old, String Email_new)             throws DataException, RemoteException;
        // removeEmail: Metodo que elimina un e-mail de los existentes
        public void removeEmail(String Email)                                   throws DataException, RemoteException;

        // DML
        // insertTelefonoBD: Metodo que inserta un Telefono en la BD
        public int insertTelefonoBD(String Telefono)                            throws DataException, SQLException, RemoteException;
        // updateTelefonoBD: Metodo que actualiza un Telefono de la BD
        public int updateTelefonoBD(String Tfno_old, String Tfno_new)           throws DataException, SQLException, RemoteException;
        // removeTelefonoBD: Metodo que borra un Telefono de la BD
        public int removeTelefonoBD(String Telefono)                            throws DataException, SQLException, RemoteException;
        // insertTelefonosBD: Metodo que inserta los Telefonos en la BD
        public int insertTelefonosBD()                                          throws DataException, SQLException, RemoteException;
        // insertTelefonosBD: Metodo que inserta los Telefonos en la BD
        public int insertTelefonosBD(Personal Persona)                  throws DataException, SQLException, SQLException, RemoteException;
        // updateTelefonosBD: Metodo que actualiza los Telefonos de la BD
        public int updateTelefonosBD()                                          throws DataException, SQLException, SQLException, RemoteException;
        // removeTelefonosBD: Metodo que borra los Telefonos de la BD
        public int removeTelefonosBD()                                          throws DataException, SQLException, RemoteException;
        // removeTelefonosBD: Metodo que borra los Telefonos de una persona de la BD
        public int removeTelefonosBD(Personal Persona)                          throws DataException, SQLException, RemoteException;
        // insertEmailBD: Metodo que inserta un Email en la BD
        public int insertEmailBD(String Email)                                  throws DataException, SQLException, RemoteException;
        // updateEmailBD: Metodo que actualiza un Email de la BD
        public int updateEmailBD(String Email_old, String Email_new)            throws DataException, SQLException, RemoteException;
        // removeEmailBD: Metodo que borra un Email de la BD
        public int removeEmailBD(String Email)                                  throws DataException, SQLException, RemoteException;
        // insertEmailsBD: Metodo que inserta los Emails en la BD
        public int insertEmailsBD()                                             throws DataException, SQLException, RemoteException;
        // insertEmailsBD: Metodo que inserta los Emails en la BD
        public int insertEmailsBD(Personal Persona)                             throws DataException, SQLException, RemoteException;
        // updateEmailsBD: Metodo que actualiza los Emails de la BD
        public int updateEmailsBD()                                             throws DataException, SQLException, RemoteException;
        // removeEmailsBD: Metodo que borra los Emails de la BD
        public int removeEmailsBD()                                             throws DataException, SQLException, RemoteException;
        // removeEmailsBD: Metodo que borra los Emails de una persona de la BD
        public int removeEmailsBD(Personal Persona)                             throws DataException, SQLException, RemoteException;
        // insertPersonalBD: Metodo que inserta el Personal en la BD
        public int insertPersonalBD()                                           throws DataException, SQLException, RemoteException;
        // updatePersonalBD: Metodo que actualiza el Personal en la BD
        public int updatePersonalBD(Personal Persona)                           throws DataException, SQLException, RemoteException;
        // removePersonalBD: Metodo que borra un Personal de la BD
        public int removePersonalBD()                                           throws SQLException, RemoteException;

        // FUNCIONALIDADES
        // obtenerPersonalCuentas: Metodo que devuelve todo el personal que puede tener cuentas en el sistema, pasando previamente un filtro dado
        public ResultSet obtenerPersonalCuentas(String Filtro)                  throws SQLException, RemoteException;
        // obtenerPersonalCentro: Metodo que devuelve todo el personal accesor al centro que se encuentra fuera de el, pasando un filtro dado
        public ResultSet obtenerPersonalCentro(String Filtro)                   throws SQLException, RemoteException;
        // obtenerPersonalCentro: Metodo que devuelve todo el personal accesor al centro
        public ArrayList<String> obtenerPersonalCentro()                        throws SQLException, RemoteException;
        // obtenerDNI: Metodo que devuelve el DNI de una persona
        public String obtenerDNI()                                              throws SQLException, RemoteException;
        // obtenerDNI: Metodo que devuelve el DNI de una persona
        public String obtenerDNI(String apellidosNombre)                        throws DataException, SQLException, RemoteException;
        // obtenerTfns: Metodo que devuelve los telefonos de esta persona
        public ResultSet obtenerTfns()                                          throws SQLException, RemoteException;
        // obtenerLsPrestables: Metodo que devuelve las llaves prestables a una persona dada
        public ResultSet obtenerLsPrestables(String DNI)                        throws SQLException, RemoteException;
        // obtenerEmails: Metodo que devuelve los e-mails de esta persona
        public ResultSet obtenerEmails()                                        throws SQLException, RemoteException;
        // obtenerCargos: Metodo que devuelve los cargos de esta persona
        public ResultSet obtenerCargos()                                        throws SQLException, RemoteException;
        // obtenerCargosEmp: Metodo que devuelve los cargos de esta persona en una empresa dada
        public ResultSet obtenerCargosEmp(String Nom_Emp)                       throws SQLException, RemoteException;
        // obtenerCargosDep: Metodo que devuelve los cargos de esta persona en una empresa y departamento dados
        public ResultSet obtenerCargosDep(String Nom_Emp, String Nom_Dep)       throws SQLException, RemoteException;
        // obtenerTipo: Metodo que devuelve el tipo de persona
        public String obtenerTipo()                                             throws SQLException, RemoteException;
        // obtenerEmpresa: Metodo que devuelve la empresa para la que trabaja
        public String obtenerEmpresa()                                          throws SQLException, RemoteException;
        // obtenerResponsable: Metodo que devuelve el DNI de la persona responsable del departamento donde trabaja o "" si no tiene responsable o la persona no es de tipo Periodico
        public String obtenerResponsable()                                      throws SQLException, RemoteException;
        // existe: Metodo que denota si una persona existe en la BD
        public boolean existe()                                                 throws SQLException, RemoteException;
        // obtenerInsertadores: Metodo que devuelve todo el personal que puede ser insertador en la BD
        public ResultSet obtenerInsertadores()                                  throws SQLException, RemoteException;
        // obtenerDatosPrestamosPendientes: Metodo que obtiene los datos de todos los prestamos pendientes
        public ResultSet obtenerDatosPrestamosPendientes()                      throws SQLException, RemoteException;
        // obtenerDatosPrestamosPendientes: Metodo que obtiene los datos de todos los prestamos pendientes que estan pendientes de devolucion desde un numero de dias indicado
        public ResultSet obtenerDatosPrestamosPendientes(int Dias)              throws SQLException, RemoteException;
        // eliminarPersonal: Metodo que borra todas aquellas personas que constan en Personal y no disponen de ninguna especializacion en ninguna tabla derivada
        public int eliminarPersonal()                                           throws SQLException, RemoteException;
}