// PAQUETE
package API.Interfaces_RMI;

// IMPORTACIONES
import API.Excepciones.DataException;
import API.Tablas.Nivel;
import API.Tablas.Residente;
import java.rmi.*;
import java.sql.SQLException;



/** INTERFAZ RESIDENTE_I:  Interfaz que establece los metodos a implementar en el uso de la tabla Residente
 *
 * @author  Napal Basterrica, Hector
 * @version 1.0
 *
 */
public interface Residente_I extends Remote
{
	// METODOS -------------------------------------------------------------
	// OBTENCION Y ESTABLECIMIENTO DE PARAMETROS
        // getNivel: Metodo que obtiene el valor del atributo Nivel
	public Nivel getNivel()                             throws RemoteException;
        // setNivel: Metodo que establece el valor del atributo Nivel
	public void setNivel(Nivel Nivel)                   throws DataException, RemoteException;

        // DML
        // insertResidenteBD: Metodo que inserta el Residente en la BD
        public int insertResidenteBD()                      throws DataException, SQLException, RemoteException;
        // updateResidenteBD: Metodo que actualiza el Residente en la BD
        public int updateResidenteBD(Residente Residente)   throws DataException, SQLException, RemoteException;
        // removeResidenteBD: Metodo que borra un Residente de la BD
        public int removeResidenteBD()                      throws SQLException, RemoteException;
}