// PAQUETE
package API.Interfaces_RMI;

// IMPORTACIONES
import API.Excepciones.DataException;
import API.Tablas.Nivel;
import API.Tablas.T_Acceso;
import java.rmi.*;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.Calendar;



/** INTERFAZ T_ACCESO_I:  Interfaz que establece los metodos a implementar en el uso de la tabla T_Acceso
 *
 * @author  Napal Basterrica, Hector
 * @version 1.0
 *
 */
public interface T_Acceso_I extends Remote
{
	// METODOS -------------------------------------------------------------
	// OBTENCION Y ESTABLECIMIENTO DE PARAMETROS
        // getCodAcc: Metodo que obtiene el valor del atributo Cod_Acc
	public String getCodAcc()			throws RemoteException;
        // setCodAcc: Metodo que establece el valor del atributo Cod_Acc
	public void setCodAcc(String Cod_Acc)           throws DataException, RemoteException;
        // getActividad: Metodo que obtiene el valor del atributo Actividad
	public String getActividad()			throws RemoteException;
        // setActividad: Metodo que establece el valor del atributo Actividad
	public void setActividad(String Actividad)      throws DataException, RemoteException;
        // getDias: Metodo que obtiene el valor del atributo Dias
	public String getDias()                      throws RemoteException;
        // setDias: Metodo que establece el valor del atributo Dias
	public void setDias(String Dias)             throws DataException, RemoteException;
        // getAutTel: Metodo que obtiene el valor del atributo Aut_Tel
	public boolean getAutTel()                      throws RemoteException;
        // setAutTel: Metodo que establece el valor del atributo Aut_Tel
	public void setAutTel(boolean Aut_Tel)          throws RemoteException;
        // getNivel: Metodo que obtiene el valor del atributo Nivel
	public Nivel getNivel()                         throws RemoteException;
        // setNivel: Metodo que establece el valor del atributo Nivel
	public void setNivel(Nivel Nivel)               throws RemoteException;

        // TOSTRING
        // timeToString: Metodo que pasa una hora a una String
        public String timeToString (Calendar Hora)      throws RemoteException;
        // stringToTime: Metodo que pasa una String a objeto Calendar con solo hora
        public Calendar stringToTime(String Hora)       throws RemoteException;

        // DML
        // insertTAccesoBD: Metodo que inserta el T_Acceso en la BD
        public int insertTAccesoBD()                    throws SQLException, RemoteException;
        // updateTAccesoBD: Metodo que actualiza el T_Acceso en la BD
        public int updateTAccesoBD(T_Acceso T_Acceso)   throws SQLException, RemoteException;
        // removeTAccesoBD: Metodo que borra un T_Acceso de la BD
        public int removeTAccesoBD()                    throws SQLException, RemoteException;

        // FUNCIONALIDADES
        // obtenerTAccesos: Metodo que obtiene los tipos de acceso existentes
        public ResultSet obtenerTAccesos()              throws SQLException, RemoteException;
}