// PAQUETE
package API.Interfaces_RMI;

// IMPORTACIONES
import API.Excepciones.DataException;
import API.Tablas.T_Usuario;
import java.rmi.*;
import java.sql.ResultSet;
import java.sql.SQLException;



/** INTERFAZ T_USUARIO_I:  Interfaz que establece los metodos a implementar en el uso de la tabla T_Usuario
 *
 * @author  Napal Basterrica, Hector
 * @version 1.0
 *
 */
public interface T_Usuario_I extends Remote
{
	// METODOS -------------------------------------------------------------
	// OBTENCION Y ESTABLECIMIENTO DE PARAMETROS
        // getTipo: Metodo que obtiene el valor del atributo Tipo
	public String getTipo()                             throws RemoteException;
        // setTipo: Metodo que establece el valor del atributo estado
	public void setTipo(String Tipo)                    throws DataException, RemoteException;
        // getDescripcion: Metodo que obtiene el valor del atributo Descripcion
	public String getDescripcion()                      throws RemoteException;
        // setDescripcion: Metodo que establece el valor del atributo Descripcion
	public void setDescripcion(String Descripcion)      throws DataException, RemoteException;

        // DML
        // insertTUsuarioBD: Metodo que inserta el T_Usuario en la BD
        public int insertTUsuarioBD()                       throws SQLException, RemoteException;
        // updateTUsuarioBD: Metodo que actualiza el T_Usuario en la BD
        public int updateTUsuarioBD(T_Usuario T_Usuario)    throws SQLException, RemoteException;
        // removeTUsuarioBD: Metodo que borra un T_Usuario de la BD
        public int removeTUsuarioBD()                       throws SQLException, RemoteException;

        // FUNCIONALIDADES
        // obtenerCodsTUsuarios: Metodo que devuelve todos codigos de los tipos de usuarios existentes en el sistema
        public ResultSet obtenerCodsTUsuarios()             throws DataException, SQLException, RemoteException;
        // obtenerTUsuarios: Metodo que devuelve todos tipos de usuarios existentes en el sistema
        public ResultSet obtenerTUsuarios()                 throws DataException, SQLException, RemoteException;
}