// PAQUETE
package API.Interfaces_RMI;

// IMPORTACIONES
import API.Excepciones.DataException;
import API.Tablas.Color;
import API.Tablas.Tarjeta;
import API.Tablas.Personal;
import java.rmi.*;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.ArrayList;



/** INTERFAZ TARJETA_I:  Interfaz que establece los metodos a implementar en el uso de la tabla Tarjeta
 *
 * @author  Napal Basterrica, Hector
 * @version 1.0
 *
 */
public interface Tarjeta_I extends Remote
{
	// METODOS -------------------------------------------------------------
	// OBTENCION Y ESTABLECIMIENTO DE PARAMETROS
        // getCodTarj: Metodo que obtiene el valor del atributo Cod_Tarj
	public int getCodTarj()                                             throws RemoteException;
        // setCodTarj: Metodo que establece el valor del atributo Cod_Tarj
	public void setCodTarj(int Cod_Tarj)                                throws DataException, RemoteException;
        // getColor: Metodo que obtiene el valor del atributo Color
	public Color getColor()                                             throws RemoteException;
        // setColor: Metodo que establece el valor del atributo Color
	public void setColor(Color Color)                                   throws DataException, RemoteException;
        // getPersona: Metodo que obtiene el valor del atributo Persona
        public Personal getPersona()                                throws RemoteException;
        // setPersona: Metodo que establece el valor del atributo Persona
        public void setPersona(Personal Persona)                    throws DataException, RemoteException;
        
        // DML
        // insertTarjetaBD: Metodo que inserta la Tarjeta en la BD
        public int insertTarjetaBD()                                        throws SQLException, RemoteException;
        // updateTarjeta: Metodo que actualiza la Tarjeta en la BD
        public int updateTarjetaBD(Tarjeta Tarjeta)                         throws SQLException, RemoteException;
        // devTarjetaBD: Metodo que devuelve la Tarjeta en la BD
        public int devTarjetaBD()                                           throws SQLException, RemoteException;
        // darBajaTarjetaBD: Metodo que da de baja la Tarjeta en la BD
        public int darBajaTarjetaBD()                                       throws SQLException, RemoteException;
        // removeTarjeta: Metodo que borra una Tarjeta en la BD
        public int removeTarjetaBD()                                        throws SQLException, RemoteException;

        
        // FUNCIONALIDADES
        // obtenerTarjetas: Metodo que devuelve los codigos de tarjetas que estan en circulacion
        public ResultSet obtenerTarjetas()                                  throws SQLException, RemoteException;
        // obtenerColoresTarjs: Metodo que devuelve los colores de las tarjetas que estan en circulacion
        public ArrayList obtenerColoresTarjs()                              throws SQLException, RemoteException;
        // obtenerColoresTarjsPrest: Metodo que devuelve los colores de las tarjetas que estan en prestamo
        public ArrayList obtenerColoresTarjsPrest()                         throws SQLException, RemoteException;
        // obtenerPrestamos: Metodo que devuelve los datos de todas las tarjetas que permanecen en prestamo
        public ResultSet obtenerPrestamos()                                 throws SQLException, RemoteException;
        // numTarjPorDefecto: Metodo que devuelve el numero de tarjeta por defecto
        public int numTarjPorDefecto()                                      throws SQLException, RemoteException;
        // numTarjAcc: Metodo que devuelve el numero de tarjeta seleccionado para el acceso segun el color proporcionado
        public int numTarjAcc(int Color)                                    throws SQLException, RemoteException;
        // eliminarTarjetas: Metodo que borra todas las tarjetas mas antiguas de Dias dias
        public int eliminarTarjetas(int Dias)                               throws SQLException, RemoteException;
        // disparador: Metodo que ejecuta el disparador sobre BEFORE INSERT ON Tarjeta
        public int disparador()                                             throws SQLException, RemoteException;
}