// PAQUETE
package API.Interfaces_RMI;

// IMPORTACIONES
import java.rmi.*;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;



/** INTERFAZ UTILIDADESBD_I:  Interfaz que establece los metodos a implementar en el uso de la clase UtilidadesBD
 *
 * @author  Napal Basterrica, Hector
 * @version 1.0
 *
 */
public interface UtilidadesBD_I extends Remote
{
	// METODOS -------------------------------------------------------------
	// OBTENCION Y ESTABLECIMIENTO DE PARAMETROS
        // getDireccionURL: Metodo que obtiene el valor del atributo DireccionURL
        public String getDireccionURL()                                                                 throws RemoteException;
        // setDireccionURL: Metodo que establece el valor del atributo DireccionURL
        public void setDireccionURL (String DireccionURL)                                               throws RemoteException;

	// EJECUTAR CONSULTAS
        // abrirConexion: Metodo que abre una conexion con la BD
        public Statement abrirConexion()                                                                throws SQLException, RemoteException;
        // cerrarConexion: Metodo que cierra la conexion con la BD
        public void cerrarConexion()                                                                    throws SQLException, RemoteException;
        // ejecutarQuery: Metodo que conecta con una BD, ejecuta una consulta DML y devuelve el resultado obtenido
        public ResultSet ejecutarQuery(String Query)                                                    throws SQLException, RemoteException;
        // ejecutarQuery: Metodo que conecta con una BD, ejecuta una consulta DML y devuelve el resultado obtenido
        public ResultSet ejecutarQuery(String DireccionURL, String Usuario, String Pass, String Query)  throws SQLException, RemoteException;
        // ejecutarUpdate: Metodo que conecta con una BD, ejecuta una consulta de DDL y devuelve el numero de filas actualizadas
        public int ejecutarUpdate(String Query)                                                         throws SQLException, RemoteException;
        // ejecutarUpdate: Metodo que conecta con una BD, ejecuta una consulta de DDL y devuelve el numero de filas actualizadas
        public int ejecutarUpdate(String DireccionURL, String Usuario, String Pass, String Query)       throws SQLException, RemoteException;
}