// PAQUETE
package API.Interfaces_RMI;

// IMPORTACIONES
import API.Excepciones.DataException;
import API.Tablas.Empresa;
import API.Tablas.GLL_Dev;
import API.Tablas.Llave;
import java.rmi.*;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.HashMap;
import javax.swing.JComboBox;
import javax.swing.JTable;
import javax.swing.table.DefaultTableModel;



/** INTERFAZ UTILIDADESCALENDAR_I:  Interfaz que establece los metodos a implementar en el uso de la clase UtilidadesCalendar
 *
 * @author  Napal Basterrica, Hector
 * @version 1.0
 *
 */
public interface UtilidadesGUI_I extends Remote
{
	// METODOS -------------------------------------------------------------
	// JTABLES
        // rsToTableModel: Metodo que crea un DefaultTableModel a partir de un ResultSet
        public DefaultTableModel rsToTableModel(ResultSet rs)                           throws SQLException, RemoteException;
        // rellenarTabla: Metodo que rellena una JTable con un ResultSet
        public void rellenarTabla(JTable tabla, ResultSet rs)                           throws SQLException, RemoteException;
        // pintarTabla: Metodo que pinta las celdas de una JTable segun un ArrayList de colores
        public void pintarTabla(JTable tabla, ArrayList al)                             throws DataException, SQLException, RemoteException;
        // rellenarTablaTelefonos: Metodo que rellena el JTable de telefonos con un ArrayList
        public void rellenarTablaTelefonos(JTable tabla, ArrayList<String> al)          throws SQLException, RemoteException;
        // rellenarTablaPrestamos: Metodo que rellena el JTable de prestamos con un HashMap
        public void rellenarTablaPrestamos(JTable tabla, HashMap<String,GLL_Dev> hm)    throws SQLException, RemoteException;
        // rellenarTablaEmpresas: Metodo que rellena el JTable de Empresas con las empresas existentes y el HashMap de empresas a introducir
        public void rellenarTablaEmpresas(JTable tabla, ResultSet rs, HashMap<Integer,Empresa> hm)      throws SQLException, RemoteException;
        // rellenarTablaDepartamentos: Metodo que rellena el JTable de Departamentos con el HashMap de empresas a introducir
        public void rellenarTablaDepartamentos(JTable tabla, HashMap<Integer,Empresa> hm, int Emp_i)    throws SQLException, RemoteException;
        // rellenarTablaLs: Metodo que rellena el JTable de llaves con un HashMap de llaves
        public void rellenarTablaLs(JTable tabla, HashMap<String,Llave> hm)             throws SQLException, RemoteException;

        // JCOMBOBOXES
        // rellenarJCB: Metodo que rellena un JComboBox con un ResultSet
        public void rellenarJCB(JComboBox JCB, ResultSet rs)                            throws SQLException, RemoteException;
}