// PAQUETE
package API.Interfaces_RMI;

// IMPORTACIONES
import API.Excepciones.DataException;
import java.rmi.*;
import java.sql.ResultSet;
import java.sql.SQLException;



/** INTERFAZ VIGILANTE_I:  Interfaz que establece los metodos a implementar en el uso de la tabla Vigilante
 *
 * @author  Napal Basterrica, Hector
 * @version 1.0
 *
 */
public interface Vigilante_I extends Remote
{
	// METODOS -------------------------------------------------------------
	// OBTENCION Y ESTABLECIMIENTO DE PARAMETROS
        // getCodVig: Metodo que obtiene el valor del atributo Cod_Vig
	public int getCodVig()                                  throws RemoteException;
        // setCodVig: Metodo que establece el valor del atributo Cod_Vig
	public void setCodVig(int Cod_Vig)                      throws DataException, RemoteException;

        // FUNCIONALIDADES
        // existeVigilante: Metodo que denota si existe un vigilante con el codigo de vigilante proporcionado
	public boolean existeVigilante()                        throws SQLException, RemoteException;
        // obtenerCodsVigilantes: Metodo que obtiene todos los codigos de vigilante de los vigilantes del centro
        public ResultSet obtenerCodsVigilantes()                throws DataException, SQLException, RemoteException;
        // obtenerDNI: Metodo que obtiene el DNI del vigilante a partir de su codigo de vigilante
        public String obtenerDNI()                              throws SQLException, RemoteException;
}