// PAQUETE
package API.Tablas;

// IMPORTACIONES
import API.Excepciones.DataException;
import API.Interfaces_RMI.UnaFecha_I;
import java.rmi.*;
import java.util.Calendar;



/** CLASE DOSFECHAS:  Clase que representa las clases que tienen dos fechas como atributos
 *
 * @author  Napal Basterrica, Hector
 * @version 1.0
 *
 */
public class DosFechas extends UnaFecha implements UnaFecha_I
{
	// ATRIBUTOS -----------------------------------------------------------
        /** Fecha_j:                Fecha */
        private Calendar            Fecha_j;



	// METODOS -------------------------------------------------------------
	// CONSTRUCTORES
	/** Constructor: Constructor por defecto
	 *
         * @param   void
	 * @return  UnaFecha	Objeto de tipo UnaFecha
	 */
	public DosFechas() throws DataException, RemoteException
	{
            // Llamamos al constructor base
            super();

            // Realizamos la asignacion de valores a los atributos
            this.Fecha_j = null;
	}
	/** Constructor: Constructor de clase que crea el objeto DosFechas con los valores pasados parametricamente
	 *
         * @param   Fecha_i     Fecha
	 * @return  UnaFecha	Objeto de tipo UnaFecha
	 */
	public DosFechas(Calendar Fecha_i) throws DataException, RemoteException
	{
            // Llamamos al constructor base
            super(Fecha_i);

            // Realizamos la asignacion de valores a los atributos
            this.Fecha_j = null;
	}
	/** Constructor: Constructor de clase que crea el objeto DosFechas con los valores pasados parametricamente
	 *
         * @param   Fecha_i     Fecha
         * @param   Fecha_j     Fecha
	 * @return  UnaFecha	Objeto de tipo UnaFecha
	 */
	public DosFechas(Calendar Fecha_i, Calendar Fecha_j) throws DataException, RemoteException
	{
            // Llamamos al constructor base
            super(Fecha_i);

            // Comprobamos la correcion de los parametros pasados
            if ((Fecha_j != null) && (Fecha_i.after(Fecha_j)))       throw new DataException();

            // Realizamos la asignacion de valores a los atributos
            this.Fecha_j = Fecha_j;
	}


	// OBTENCION Y ESTABLECIMIENTO DE PARAMETROS
        /** getFechaJ: Metodo que obtiene el valor del atributo Fecha_j
	 *
	 * @param   void
	 * @return  Calendar	Fecha
	 */
	public Calendar getFechaJ()                             { return this.Fecha_j; }
        /** setFechaJ: Metodo que establece el valor del atributo Fecha_j
	 *
	 * @param   Fecha_i     Calendar     Fecha
	 * @return  void
	 */
	public void setFechaJ(Calendar Fecha_j) throws DataException
        {
            // Comprobamos la correcion de los parametros pasados
            if ((Fecha_j != null) && (getFechaI().after(Fecha_j)))      throw new DataException();

            // Realizamos la asignacion de valores a los atributos
            this.Fecha_j = Fecha_j;
        }

         
        // TOSTRING
        /** toString: Metodo que devuelve una String con el estado del objeto
	 *
	 * @param   void
	 * @return  s       String con informacion del estado actual del objeto
	 */
        @Override
	public String toString()
        {
            // Devolvemos el resultado
            return super.toString() + "Fecha_j: " + (getFechaJ() == null ? "" : calendarToString(getFechaJ())) + "\n";
	}
}