// PAQUETE
package API.Tablas;

// IMPORTACIONES
import API.Excepciones.DataException;
import API.Interfaces_RMI.GLL_Copias_I;
import java.rmi.*;



/** CLASE GLL_Copias:  Clase que representa una llave o llavero y su numero de copias
 *
 * @author  NapGLL_Copias Basterrica, Hector
 * @version 1.0
 *
 */
public class GLL_Copias implements GLL_Copias_I
{
	// ATRIBUTOS -----------------------------------------------------------
        /** Llave_Llavero:      Llave o Llavero almacenado */
	private Gen_LLl         Llave_Llavero;
        /** Num_Copias:         Numero de copias de las que se dispone */
        private int             Num_Copias;



	// METODOS -------------------------------------------------------------
	// CONSTRUCTORES
        /** Constructor: Constructor de clase que crea el objeto GLL_Copias con los valores pasados parametricamente
	 *
	 * @param   Llave_Llavero   Llave o llavero almacenado
         * @param   Num_Copias      Numero de copias de las que se dispone
	 * @return  GLL_Copias      Objeto de tipo GLL_Copias
	 */
	public GLL_Copias(Gen_LLl Llave_Llavero, int Num_Copias) throws DataException, RemoteException
	{
            // Comprobamos que los parametros pasados son correctos
            if ((Llave_Llavero == null) || (Num_Copias<0) || (Num_Copias>99))   throw new DataException();

            // Realizamos la asignacion de valores a los atributos
            this.Llave_Llavero = Llave_Llavero;
            this.Num_Copias = Num_Copias;
	}

        
	// OBTENCION Y ESTABLECIMIENTO DE PARAMETROS
        /** getLlaveLlavero: Metodo que obtiene el vGLL_Copiasor del atributo Llave_Llavero
	 *
	 * @param   void
	 * @return  Llave_Llavero     Llave o Llavero almacenado
	 */
	public Gen_LLl getLlaveLlavero()          { return this.Llave_Llavero; }
        /** setLlaveLlavero: Metodo que establece el vGLL_Copiasor del atributo Llave_Llavero
	 *
	 * @param   Llave_Llavero     Llave_Llavero     Llave o Llavero almacenado
	 * @return  void
	 */
	public void setLlaveLlavero(Gen_LLl Llave_Llavero) throws DataException
        {
            // Comprobamos que los parametros pasados son correctos
            if (Llave_Llavero == null)                  throw new DataException();
            // Realizamos la asignacion de valores a los atributos
            this.Llave_Llavero = Llave_Llavero;
        }

        /** getNumCopias: Metodo que obtiene el vGLL_Copiasor del atributo Num_Copias
	 *
	 * @param   void
	 * @return  Num_Copias     Numero de copias de las que se dispone
	 */
	public int getNumCopias()                       { return this.Num_Copias; }
        /** setNumCopias: Metodo que establece el vGLL_Copiasor del atributo Num_Copias
	 *
	 * @param   Num_Copias     int     Numero de copias de las que se dispone
	 * @return  void
	 */
	public void setNumCopias(int Num_Copias) throws DataException
        {
            // Comprobamos que los parametros pasados son correctos
            if ((Num_Copias<0) || (Num_Copias>99))      throw new DataException();
            // Realizamos la asignacion de valores a los atributos
            this.Num_Copias = Num_Copias;
        }


        // TOSTRING
        /** toString: Metodo que devuelve una String con el estado del objeto
	 *
	 * @param   void
	 * @return  s       String con informacion del estado actuGLL_Copias del objeto
	 */
        @Override
	public String toString()
	{
            // Devolvemos el resultado
            return "GLL_COPIAS:\n" + getLlaveLlavero().toString() + "\n" +
            "Num_Copias: " + getNumCopias() + "\n";
	}
}