// PAQUETE
package API.Tablas;

// IMPORTACIONES
import API.Excepciones.DataException;
import API.Interfaces_RMI.GLL_Dev_I;
import java.rmi.*;



/** CLASE GLL_Dev:  Clase que representa una llave o llavero y si ha sido devuelta
 *
 * @author  NapGLL_Dev Basterrica, Hector
 * @version 1.0
 *
 */
public class GLL_Dev implements GLL_Dev_I
{
	// ATRIBUTOS -----------------------------------------------------------
        /** Llave_Llavero:      Llave o Llavero prestado */
	private Gen_LLl         Llave_Llavero;
        /** Dev:                Denota si ha sido devuelta */
        private boolean         Dev;



	// METODOS -------------------------------------------------------------
	// CONSTRUCTORES
        /** Constructor: Constructor de clase que crea el objeto GLL_Dev con los valores pasados parametricamente
	 *
	 * @param   Llave_Llavero   Llave o llavero prestado
	 * @return  GLL_Dev         Objeto de tipo GLL_Dev
	 */
	public GLL_Dev(Gen_LLl Llave_Llavero) throws DataException, RemoteException
	{
            // Comprobamos que los parametros pasados son correctos
            if (Llave_Llavero == null)                              throw new DataException();

            // Realizamos la asignacion de valores a los atributos
            this.Llave_Llavero = Llave_Llavero;
            this.Dev = false;
	}
        /** Constructor: Constructor de clase que crea el objeto GLL_Dev con los valores pasados parametricamente
	 *
	 * @param   Llave_Llavero   Llave o llavero prestado
         * @param   Dev             Denota si ha sido devuelta
	 * @return  GLL_Dev         Objeto de tipo GLL_Dev
	 */
	public GLL_Dev(Gen_LLl Llave_Llavero, boolean Dev) throws DataException, RemoteException
	{
            // Comprobamos que los parametros pasados son correctos
            if (Llave_Llavero == null)                              throw new DataException();

            // Realizamos la asignacion de valores a los atributos
            this.Llave_Llavero = Llave_Llavero;
            this.Dev = Dev;
	}

        
	// OBTENCION Y ESTABLECIMIENTO DE PARAMETROS
        /** getLlaveLlavero: Metodo que obtiene el valor del atributo Llave_Llavero
	 *
	 * @param   void
	 * @return  Llave_Llavero     Llave o Llavero prestado
	 */
	public Gen_LLl getLlaveLlavero()            { return this.Llave_Llavero; }
        /** setLlaveLlavero: Metodo que establece el valor del atributo Llave_Llavero
	 *
	 * @param   Llave_Llavero     Llave_Llavero     Llave o Llavero prestado
	 * @return  void
	 */
	public void setLlaveLlavero(Gen_LLl Llave_Llavero) throws DataException
        {
            // Comprobamos que los parametros pasados son correctos
            if (Llave_Llavero == null)                  throw new DataException();
            // Realizamos la asignacion de valores a los atributos
            this.Llave_Llavero = Llave_Llavero;
        }

        /** getDev: Metodo que obtiene el valor del atributo Dev
	 *
	 * @param   void
	 * @return  Dev     Denota si la Llave o Llavero ha sido devuelta
	 */
	public boolean getDev()                     { return this.Dev; }
        /** setDev: Metodo que establece el valor del atributo Dev
	 *
	 * @param   Dev     boolean     Denota si la Llave o Llavero ha sido devuelta
	 * @return  void
	 */
	public void setDev(boolean Dev)             { this.Dev = Dev; }     // Realizamos la asignacion de valores a los atributos


        // TOSTRING
        /** toString: Metodo que devuelve una String con el estado del objeto
	 *
	 * @param   void
	 * @return  s       String con informacion del estado actual del objeto
	 */
        @Override
	public String toString()
	{
            // Devolvemos el resultado
            return "GLL_DEV:\n" + getLlaveLlavero().toString() + "\n" +
            "Devuelto: " + (getDev() ? "Sí" : "No") + "\n";
	}
}