// PAQUETE
package API.Tablas;

// IMPORTACIONES
import API.Excepciones.DataException;
import API.Interfaces_RMI.UnaFecha_I;
import API.Utilidades.UtilidadesCalendar;
import java.rmi.*;
import java.util.Calendar;



/** CLASE UNAFECHA:  Clase que representa las clases que tienen una fecha como atributos
 *
 * @author  Napal Basterrica, Hector
 * @version 1.0
 *
 */
public class UnaFecha extends UtilidadesCalendar implements UnaFecha_I
{
	// ATRIBUTOS -----------------------------------------------------------
        /** Fecha_i:                Fecha */
        protected Calendar          Fecha_i;



	// METODOS -------------------------------------------------------------
	// CONSTRUCTORES
        /** Constructor: Constructor por defecto
         *
         * @param   void
         * @return  UnaFecha    Objeto de tipo UnaFecha
         */
        public UnaFecha() throws RemoteException
        {
            // Realizamos la asignacion de valores a los atributos
            this.Fecha_i = Calendar.getInstance();
        }
	/** Constructor: Constructor de clase que crea el objeto UnaFecha con el valor pasado parametricamente
	 *
         * @param   Fecha_i     Fecha
	 * @return  UnaFecha	Objeto de tipo UnaFecha
	 */
	public UnaFecha(Calendar Fecha_i) throws DataException, RemoteException
	{
            // Comprobamos que los parametros pasados son correctos
            if (Fecha_i == null)                throw new DataException();

            // Realizamos la asignacion de valores a los atributos
            this.Fecha_i = Fecha_i;
	}


	// OBTENCION Y ESTABLECIMIENTO DE PARAMETROS
        /** getFechaI: Metodo que obtiene el valor del atributo Fecha_i
	 *
	 * @param   void
	 * @return  Calendar	Fecha
	 */
	public Calendar getFechaI()                             { return this.Fecha_i; }
        /** setFechaI: Metodo que establece el valor del atributo Fecha_i
	 *
	 * @param   Fecha_i     Calendar     Fecha
	 * @return  void
	 */
	public void setFechaI(Calendar Fecha_i) throws DataException
        {
            // Comprobamos que los parametros pasados son correctos
            if (Fecha_i == null)                                throw new DataException();
            // Realizamos la asignacion de valores a los atributos
            this.Fecha_i = Fecha_i;
        }


        // TOSTRING
        /** toString: Metodo que devuelve una String con el estado del objeto
	 *
	 * @param   void
	 * @return  s       String con informacion del estado actual del objeto
	 */
        @Override
	public String toString()
        {
            // Devolvemos el resultado
            return "Fecha_i: " + calendarToString(getFechaI()) + "\n";
	}
}