// PAQUETE
package API.Utilidades;

// IMPORTACIONES
import API.Excepciones.DataException;
import java.awt.Component;
import java.awt.Color;
import java.rmi.RemoteException;
import java.sql.SQLException;
import java.util.ArrayList;
import javax.swing.table. DefaultTableCellRenderer;
import javax.swing.*;



/** CLASE RENDER:  Clase que encargada de pintar JTables
 *
 * @author  Napal Basterrica, Hector
 * @version 1.0
 *
 */
public class Render extends DefaultTableCellRenderer
{
        // ATRIBUTOS
        /** colores:                        ArrayList con los colores con los que pintar la JTable*/
        private ArrayList                   colores;



	// METODOS -------------------------------------------------------------
	// CONSTRUCTORES
	/** Constructor: Constructor de clase que crea el objeto Render con los valores pasados parametricamente
         *
         * @param   ArrayList   Colores         ArrayList con los colores con los que pintar la JTable
         * @return  Render                      Objeto de tipo Render
         */
        public Render(ArrayList Colores) throws RemoteException
        {
            // Establecemos el valor del atributo
            this.colores = Colores;
        }


	// PINTAR
        /** getCellRendereComponent: Metodo que obtiene el componente (celda) pintado
	 *
	 * @param   JTable          table       Tabla a colorear
         * @param   Object          value
         * @param   boolean         isSelected
         * @param   boolean         hasFocus
         * @param   int             row         Fila de la celda
         * @param   int             column      Columna de la celda
	 * @return  Component       cell        Celda coloreada
	 */
        public Component getTableCellRendererComponent(JTable table, Object value, boolean isSelected, boolean hasFocus, int row, int column)
        {
            // Obtenemos el render de la celda
            Component cell = super.getTableCellRendererComponent (table, value, isSelected, hasFocus, row, column);
            // Establecemos el color
            cell.setBackground(new Color((Integer) colores.get(row)));

            // Devolvemos el componente
            return cell;
        }
}