// PAQUETE
package GUI.UIs;

// IMPORTACIONES
import API.Excepciones.DataException;
import API.Tablas.Cuenta;
import java.rmi.RemoteException;
import java.sql.SQLException;
import javax.swing.JFrame;
import javax.swing.JOptionPane;



/** CLASE IDENTIFICACION:  Clase que representa el JFrame con el que se inicia la aplicacion y
 *                         en el que el usuario debe loguearse
 *
 * @author  Napal Basterrica, Hector
 * @version 1.0
 *
 */
public class Identificacion extends JFrame
{
	// METODOS -------------------------------------------------------------
	// CONSTRUCTORES
	/** Constructor: Constructor de clase que crea el objeto Identificacion con los valores pasados parametricamente
         *
         * @param   void
         * @return  JFrame      Identificacion    Objeto de tipo Identificacion
         */
        public Identificacion()
        {
            // Dibujamos todos los componentes
            initComponents();
            // Centramos el JFrame en la pantalla
            this.setLocationRelativeTo(null);
        }


	// DIBUJO
        /** initComponents: Metodo que dibuja toda la GUI de Identificacion
	 *
	 * @param   void
	 * @return  void
	 */
        @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        JPTotal = new javax.swing.JPanel();
        JLLogo = new javax.swing.JLabel();
        jPanel1 = new javax.swing.JPanel();
        JLUsuario = new javax.swing.JLabel();
        JLPass = new javax.swing.JLabel();
        JPFPass = new javax.swing.JPasswordField();
        JTFUsuario = new javax.swing.JTextField();
        JBEntrar = new javax.swing.JButton();
        JBAyuda = new javax.swing.JButton();

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);
        setTitle("accessManager");
        setBackground(new java.awt.Color(216, 222, 240));
        setBounds(new java.awt.Rectangle(0, 0, 0, 0));
        setExtendedState(JFrame.MAXIMIZED_BOTH);
        setName("Identificación"); // NOI18N
        setResizable(false);

        JPTotal.setBackground(new java.awt.Color(255, 255, 255));

        JLLogo.setIcon(new javax.swing.ImageIcon(getClass().getResource("/GUI/Imgs/in_logo_mini.gif"))); // NOI18N

        jPanel1.setBackground(new java.awt.Color(255, 255, 255));

        JLUsuario.setText("Usuario");

        JLPass.setText("Contraseña");

        JPFPass.setToolTipText("");
        JPFPass.setName("Pass"); // NOI18N

        JTFUsuario.setToolTipText("");

        javax.swing.GroupLayout jPanel1Layout = new javax.swing.GroupLayout(jPanel1);
        jPanel1.setLayout(jPanel1Layout);
        jPanel1Layout.setHorizontalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel1Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(JLUsuario)
                    .addComponent(JLPass))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                    .addComponent(JTFUsuario)
                    .addComponent(JPFPass, javax.swing.GroupLayout.DEFAULT_SIZE, 91, Short.MAX_VALUE))
                .addContainerGap())
        );
        jPanel1Layout.setVerticalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel1Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(JLUsuario)
                    .addComponent(JTFUsuario, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(JLPass)
                    .addComponent(JPFPass, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        JLUsuario.getAccessibleContext().setAccessibleName("JLUsuario");
        JLPass.getAccessibleContext().setAccessibleName("JLPass");
        JPFPass.getAccessibleContext().setAccessibleName("JTFPass");
        JPFPass.getAccessibleContext().setAccessibleDescription(null);
        JTFUsuario.getAccessibleContext().setAccessibleName("JTFUsuario");
        JTFUsuario.getAccessibleContext().setAccessibleDescription(null);

        JBEntrar.setIcon(new javax.swing.ImageIcon(getClass().getResource("/GUI/Icons/accept.png"))); // NOI18N
        JBEntrar.setToolTipText("");
        JBEntrar.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                JBEntrarActionPerformed(evt);
            }
        });

        JBAyuda.setIcon(new javax.swing.ImageIcon(getClass().getResource("/GUI/Icons/help.png"))); // NOI18N
        JBAyuda.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                JBAyudaActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout JPTotalLayout = new javax.swing.GroupLayout(JPTotal);
        JPTotal.setLayout(JPTotalLayout);
        JPTotalLayout.setHorizontalGroup(
            JPTotalLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, JPTotalLayout.createSequentialGroup()
                .addContainerGap()
                .addComponent(JLLogo, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jPanel1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(JPTotalLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(JBAyuda)
                    .addComponent(JBEntrar))
                .addContainerGap())
        );
        JPTotalLayout.setVerticalGroup(
            JPTotalLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(JPTotalLayout.createSequentialGroup()
                .addGroup(JPTotalLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(JPTotalLayout.createSequentialGroup()
                        .addContainerGap()
                        .addGroup(JPTotalLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(jPanel1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addGroup(JPTotalLayout.createSequentialGroup()
                                .addGap(5, 5, 5)
                                .addComponent(JBEntrar)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(JBAyuda))))
                    .addGroup(JPTotalLayout.createSequentialGroup()
                        .addGap(19, 19, 19)
                        .addComponent(JLLogo)))
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        JLLogo.getAccessibleContext().setAccessibleName("JLLogo");
        JBEntrar.getAccessibleContext().setAccessibleName("JBEntrar");
        JBEntrar.getAccessibleContext().setAccessibleDescription(null);

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(JPTotal, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(JPTotal, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        JPTotal.getAccessibleContext().setAccessibleName("JPTotal");

        getAccessibleContext().setAccessibleDescription("Frame de identificación");

        pack();
    }// </editor-fold>//GEN-END:initComponents


   	// EVENTOS
    private void JBEntrarActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_JBEntrarActionPerformed
        try
        {
            // Obtenemos el nombre de usuario
            String Usuario = JTFUsuario.getText();

            // Obtenemos el password
            char passArray[] = JPFPass.getPassword();
            // Revisar que sean letras y numeros
            for (int i = 0; i < passArray.length; i++)  { char c = passArray[i]; }
            String Pass = new String(passArray);

            // Creamos un objeto de tipo cuenta
            Cuenta Cuenta = new Cuenta (Usuario);
            // Si la creacion de la Cuenta no da un DataException es que el usuario existe -> Comprobamos que la contraseña introducida es la correcta
            String Tipo_Usuario = Cuenta.checkPass(Pass);

            // Si usuario y contraseña casan -> Desplegamos la aplicacion en funcion del tipo de usuario que se trate
            if (!Tipo_Usuario.equals("Inexistente"))
            {
                // Abrimos la aplicacion
                new Aplicacion(Usuario,Tipo_Usuario,Cuenta.getPersona().getDNI()).setVisible(true);
                // Cerramos este Frame
                this.dispose();
            }
            else                        JOptionPane.showMessageDialog(this,"Nombre de usuario y/o contraseña no válidos.","ERROR",JOptionPane.ERROR_MESSAGE);
        }
        // Tratamos los diversos tipos de errores
        catch (DataException de)        { JOptionPane.showMessageDialog(this,"Error en la introducción de datos.","ERROR",JOptionPane.ERROR_MESSAGE); }
        catch (SQLException sqle)       { JOptionPane.showMessageDialog(this,"Error al conectar con el servidor de BD.","ERROR",JOptionPane.ERROR_MESSAGE); }
        catch (RemoteException re)      { JOptionPane.showMessageDialog(this,"Error al conectar con el servidor RMI.","ERROR",JOptionPane.ERROR_MESSAGE); }
    }//GEN-LAST:event_JBEntrarActionPerformed

    private void JBAyudaActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_JBAyudaActionPerformed
        JOptionPane.showMessageDialog(this,"Si necesita ayuda o desea recuperar sus claves no\ndude en escribir a admin_informaticanavarrasa@gmail.com.","AYUDA",JOptionPane.INFORMATION_MESSAGE);
    }//GEN-LAST:event_JBAyudaActionPerformed



	// MAIN
        /** main: Metodo principal ejecutable de la clase, encargado de desplegar el JFrame
	 *
	 * @param   String args[]
	 * @return  void
	 */
        public static void main(String args[])
        {
            java.awt.EventQueue.invokeLater(new Runnable() { public void run() { new Identificacion().setVisible(true); } });
        }


    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton JBAyuda;
    private javax.swing.JButton JBEntrar;
    private javax.swing.JLabel JLLogo;
    private javax.swing.JLabel JLPass;
    private javax.swing.JLabel JLUsuario;
    private javax.swing.JPasswordField JPFPass;
    private javax.swing.JPanel JPTotal;
    private javax.swing.JTextField JTFUsuario;
    private javax.swing.JPanel jPanel1;
    // End of variables declaration//GEN-END:variables
}
