// PAQUETE
package GUI.UIs;

// IMPORTACIONES
import API.Excepciones.DataException;
import API.Tablas.GLL_Dev;
import API.Tablas.Llave;
import API.Tablas.Llavero;
import API.Utilidades.UtilidadesBD;
import API.Utilidades.UtilidadesGUI;
import java.awt.Color;
import java.rmi.RemoteException;
import java.sql.SQLException;
import java.util.HashMap;
import javax.swing.JOptionPane;



/** CLASE JDACCESOLSLLS:  Clase que representa el JDialog con el que el poder seleccionar los prestamos que se quieren realizar a un acceso
 *
 * @author  Napal Basterrica, Hector
 * @version 1.0
 *
 */
public class JDAccesoLsLls extends javax.swing.JDialog
{
	// ATRIBUTOS -----------------------------------------------------------
        /** DNI:                            Usuario que desea acceder al centro */
        private static String               DNI;
        /** Entrada:                        Hora de entrada al centro */
        private static String               Entrada;
        /** pulsarExit:                     Denota si se ha salido del JDialog pulsando Exit [x] */
        private boolean                     pulsarExit = true;

        /** UGUI:                           Objeto de tipo UtilidadesGUI */
        private UtilidadesGUI               UGUI = new UtilidadesGUI();
        /** UBD:                            Objeto de tipo UtilidadesBD */
        UtilidadesBD                        UBD = new UtilidadesBD();



	// METODOS -------------------------------------------------------------
	// CONSTRUCTORES
	/** Constructor: Constructor de clase que crea el objeto JDAccesolsLls con los valores pasados parametricamente
         *
         * @param   parent      Frame           Frame padre del JDialog
         * @param   boolean     modal           Denota si el JDialog debe ser modal o no
         * @return  JDialog     JDAccesolsLls   Objeto de tipo JDAccesolsLls
         */
        public JDAccesoLsLls(java.awt.Frame parent, boolean modal, String DNI, String Entrada)
        {
            // Llamamos al constructor base
            super(parent, modal);
            // Establecemos el valor de los atributos
            this.DNI = DNI;
            this.Entrada = Entrada;
            // Dibujamos todos los componentes
            initComponents();
            // Iniciamos todos los datos necesarios del JDialog
            iniciarDatos();
            // Centramos el JDialog en la pantalla
            this.setLocationRelativeTo(null);
        }


	// DIBUJO
        /** initComponents: Metodo que dibuja toda la GUI de JDAccesolsLls
	 *
	 * @param   void
	 * @return  void
	 */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        JPLlaves = new javax.swing.JPanel();
        JSPLlaves = new javax.swing.JScrollPane();
        JTLlaves = new javax.swing.JTable();
        JPLlaveros = new javax.swing.JPanel();
        JSPLlaveros = new javax.swing.JScrollPane();
        JTLlaveros = new javax.swing.JTable();
        JTFBuscar = new javax.swing.JTextField();
        JBPrestar = new javax.swing.JButton();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        setTitle("Llaves y llaveros");

        JPLlaves.setBorder(javax.swing.BorderFactory.createTitledBorder("Llaves"));

        JTLlaves.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {

            },
            new String [] {
                "Código", "Zona", "Descripción"
            }
        ) {
            Class[] types = new Class [] {
                java.lang.String.class, java.lang.String.class, java.lang.String.class
            };
            boolean[] canEdit = new boolean [] {
                false, false, false
            };

            public Class getColumnClass(int columnIndex) {
                return types [columnIndex];
            }

            public boolean isCellEditable(int rowIndex, int columnIndex) {
                return canEdit [columnIndex];
            }
        });
        JSPLlaves.setViewportView(JTLlaves);
        JTLlaves.getAccessibleContext().setAccessibleName("JTLlaves");

        javax.swing.GroupLayout JPLlavesLayout = new javax.swing.GroupLayout(JPLlaves);
        JPLlaves.setLayout(JPLlavesLayout);
        JPLlavesLayout.setHorizontalGroup(
            JPLlavesLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(JPLlavesLayout.createSequentialGroup()
                .addContainerGap()
                .addComponent(JSPLlaves, javax.swing.GroupLayout.DEFAULT_SIZE, 370, Short.MAX_VALUE)
                .addContainerGap())
        );
        JPLlavesLayout.setVerticalGroup(
            JPLlavesLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(JPLlavesLayout.createSequentialGroup()
                .addContainerGap()
                .addComponent(JSPLlaves, javax.swing.GroupLayout.DEFAULT_SIZE, 258, Short.MAX_VALUE)
                .addContainerGap())
        );

        JSPLlaves.getAccessibleContext().setAccessibleName("JSPLlaves");

        JPLlaveros.setBorder(javax.swing.BorderFactory.createTitledBorder("Llaveros"));

        JTLlaveros.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {

            },
            new String [] {
                "Código", "Descripcion"
            }
        ) {
            Class[] types = new Class [] {
                java.lang.String.class, java.lang.String.class
            };
            boolean[] canEdit = new boolean [] {
                false, false
            };

            public Class getColumnClass(int columnIndex) {
                return types [columnIndex];
            }

            public boolean isCellEditable(int rowIndex, int columnIndex) {
                return canEdit [columnIndex];
            }
        });
        JSPLlaveros.setViewportView(JTLlaveros);
        JTLlaveros.getAccessibleContext().setAccessibleName("JTLlaveros");

        javax.swing.GroupLayout JPLlaverosLayout = new javax.swing.GroupLayout(JPLlaveros);
        JPLlaveros.setLayout(JPLlaverosLayout);
        JPLlaverosLayout.setHorizontalGroup(
            JPLlaverosLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(JPLlaverosLayout.createSequentialGroup()
                .addContainerGap()
                .addComponent(JSPLlaveros, javax.swing.GroupLayout.PREFERRED_SIZE, 363, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );
        JPLlaverosLayout.setVerticalGroup(
            JPLlaverosLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(JPLlaverosLayout.createSequentialGroup()
                .addContainerGap()
                .addComponent(JSPLlaveros, javax.swing.GroupLayout.DEFAULT_SIZE, 258, Short.MAX_VALUE)
                .addContainerGap())
        );

        JSPLlaveros.getAccessibleContext().setAccessibleName("JSPLlaveros");

        JTFBuscar.setForeground(new java.awt.Color(204, 204, 204));
        JTFBuscar.setText("Buscar ...");
        JTFBuscar.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                JTFBuscarMouseClicked(evt);
            }
        });
        JTFBuscar.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyReleased(java.awt.event.KeyEvent evt) {
                JTFBuscarKeyReleased(evt);
            }
        });

        JBPrestar.setIcon(new javax.swing.ImageIcon(getClass().getResource("/GUI/Icons/accept.png"))); // NOI18N
        JBPrestar.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                JBPrestarMouseClicked(evt);
            }
        });
        JBPrestar.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                JBPrestarActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(JPLlaves, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(JPLlaveros, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                        .addComponent(JTFBuscar, javax.swing.GroupLayout.PREFERRED_SIZE, 152, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                        .addComponent(JBPrestar)))
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(JBPrestar)
                    .addComponent(JTFBuscar, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING, false)
                    .addComponent(JPLlaveros, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(JPLlaves, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addContainerGap())
        );

        JPLlaves.getAccessibleContext().setAccessibleName("JPLlaves");
        JPLlaveros.getAccessibleContext().setAccessibleName("JPLlaveros");
        JTFBuscar.getAccessibleContext().setAccessibleName("JTFBuscar");
        JBPrestar.getAccessibleContext().setAccessibleName("JBPrestar");

        pack();
    }// </editor-fold>//GEN-END:initComponents

    
 	// INICIALIZACION
        /** iniciarDatos: Metodo que inicializa todos los datos de los componentes de la interfaz grafica
         *
         * @param   void
         * @return  void
         */
        private void iniciarDatos()
        {
            try
            {
                // Obtenemos el filtro
                String filtro = (JTFBuscar.getText().equals("Buscar ...") ? "" : JTFBuscar.getText());

                // Creamos el objeto de tipo Llave
                Llave l = new Llave();
                // Creamos el objeto de tipo Llavero
                Llavero ll = new Llavero();

                // Obtenemos las llaves prestables a la persona y que cumplan el filtro, refrescando la tabla
                // Refrescamos la tabla de llaves
                UGUI.rellenarTabla(JTLlaves,l.obtenerLlaves(DNI,Entrada,filtro));
                l.UBD.cerrarConexion();

                // Obtenemos los llaveros prestables a la persona y que cumplan el filtro, refrescando la tabla
                UGUI.rellenarTabla(JTLlaveros,ll.obtenerLlaveros(DNI,Entrada,filtro));
            }
            catch (Exception e)
            {
                JOptionPane.showMessageDialog(this,"No ha sido posible mostrar las llaves y/o llaveros.","ERROR",JOptionPane.ERROR_MESSAGE);
            }
        }


    	// EVENTOS
    private void JTFBuscarKeyReleased(java.awt.event.KeyEvent evt) {//GEN-FIRST:event_JTFBuscarKeyReleased
        // Refrescamos las tablas segun el filtro escrito hasta el momento
        iniciarDatos();
    }//GEN-LAST:event_JTFBuscarKeyReleased

    private void JBPrestarMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_JBPrestarMouseClicked
        // Escondemos el JDialog
        this.setVisible(false);
    }//GEN-LAST:event_JBPrestarMouseClicked

    private void JTFBuscarMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_JTFBuscarMouseClicked
        // Eliminamos el texto y ponemos la letra a color negro
        JTFBuscar.setText("");
        JTFBuscar.setForeground(Color.BLACK);
    }//GEN-LAST:event_JTFBuscarMouseClicked

    private void JBPrestarActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_JBPrestarActionPerformed
        // Establecemos pulsarExit a false
        this.pulsarExit = false;
    }//GEN-LAST:event_JBPrestarActionPerformed


	// FUNCIONALIDAD
        /** getLsLls: Metodo que devuelve un HashMap con todas las llaves y llaveros escogidos
	 *
	 * @param   void
	 * @return  HashMap<String,GLL_Dev>      hm         HashMap de llaves y llaveros seleccionados
	 */
        public HashMap<String,GLL_Dev> getLsLls() throws DataException, SQLException, RemoteException
        {
            // Creamos el HashMap
            HashMap<String,GLL_Dev> hm = new HashMap();

            // Obtenemos las llaves seleccionadas
            int[] llavesSelecs = JTLlaves.getSelectedRows();

            // Añadimos al HashMap todas las LLAVES seleccionadas
            for (int i=0; i<llavesSelecs.length; i++)
            {
                // CREAMOS LA LLAVE
                // Obtenemos el codigo de llave
                int cod_llave = (Integer) JTLlaves.getModel().getValueAt(llavesSelecs[i],0);
                // Creamos la llave
                Llave l = new Llave (cod_llave);
                // Creamos el GLL_Dev
                GLL_Dev glld = new GLL_Dev(l);

                // CREAMOS LA KEY
                String key = "L - " + l.getCodigo() + " - " + l.getFechaI();

                // INSERTAMOS LA LLAVE EN EL HASHMAP
                hm.put(key, glld);
            }

            // Obtenemos los llaveros seleccionados
            int[] llaverosSelecs = JTLlaveros.getSelectedRows();

            // Añadimos al HashMap todos los LLAVEROS seleccionados
            for (int i=0; i<llaverosSelecs.length; i++)
            {
                // CREAMOS EL LLAVERO
                // Obtenemos el codigo de llavero
                int cod_llavero = (Integer) JTLlaveros.getModel().getValueAt(llaverosSelecs[i],0);
                // Creamos el llavero
                Llavero ll = new Llavero (cod_llavero);
                // Creamos el GLL_Dev
                GLL_Dev glld = new GLL_Dev(ll);

                // CREAMOS LA KEY
                String key = "Ll - " + ll.getCodigo() + " - " + ll.getFechaI();

                // INSERTAMOS EL LLAVERO EN EL HASHMAP
                hm.put(key, glld);
            }

            // Devolvemos el resultado
            return hm;
        }

        /** getPulsarExit: Metodo que obtiene el valor del atributo pulsarExit, que denota si se ha salido pulsando Exit [x]
	 *
	 * @param   void
	 * @return  boolean     pulsarExit      Denota si se ha salido del JDialog pulsando Exit [x]
	 */
        public boolean getPulsarExit()      {return pulsarExit;}


	// MAIN
        /** main: Metodo principal ejecutable de la clase, encargado de desplegar el JDialog
	 *
	 * @param   String args[]
	 * @return  void
	 */
        public static void main(String args[])
        {
            java.awt.EventQueue.invokeLater(new Runnable()
            {
                public void run()
                {
                    JDAccesoLsLls dialog = new JDAccesoLsLls(new javax.swing.JFrame(), true, DNI, Entrada);
                    dialog.addWindowListener(new java.awt.event.WindowAdapter() { public void windowClosing(java.awt.event.WindowEvent e) { System.exit(0); } });
                    dialog.setVisible(true);
                }
            });
        }


    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton JBPrestar;
    private javax.swing.JPanel JPLlaveros;
    private javax.swing.JPanel JPLlaves;
    private javax.swing.JScrollPane JSPLlaveros;
    private javax.swing.JScrollPane JSPLlaves;
    private javax.swing.JTextField JTFBuscar;
    private javax.swing.JTable JTLlaveros;
    private javax.swing.JTable JTLlaves;
    // End of variables declaration//GEN-END:variables
}
