// PAQUETE
package GUI.UIs;

// IMPORTACIONES
import API.Tablas.Personal;
import API.Utilidades.UtilidadesGUI;
import java.awt.Color;
import java.sql.ResultSet;
import javax.swing.JOptionPane;


/** CLASE JDACCESOPERS:  Clase que representa el JDialog con el que el usuario puede escoger la persona que va a acceder al centro
 *
 * @author  Napal Basterrica, Hector
 * @version 1.0
 *
 */
public class JDAccesoPers extends javax.swing.JDialog
{
	// ATRIBUTOS -----------------------------------------------------------
        /** pulsarExit:                     Denota si se ha salido del JDialog pulsando Exit [x] */
        private boolean                     pulsarExit = true;

        /** UGUI:                           Objeto de tipo UtilidadesGUI */
        private UtilidadesGUI               UGUI = new UtilidadesGUI();



	// METODOS -------------------------------------------------------------
	// CONSTRUCTORES
	/** Constructor: Constructor de clase que crea el objeto JDAccesoPers con los valores pasados parametricamente
         *
         * @param   Frame       parent          Frame padre del JDialog
         * @param   modal       modal           Denota si el JDialog debe ser modal o no
         * @return  JDialog     JDAccesoPers    Objeto de tipo JDAccesoPers
         */
        public JDAccesoPers(java.awt.Frame parent, boolean modal)
        {
            // Llamamos al constructor base
            super(parent, modal);
            // Dibujamos todos los componentes
            initComponents();
            // Iniciamos todos los datos necesarios del JDialog
            iniciarDatos();
            // Centramos el JDialog en la pantalla
            this.setLocationRelativeTo(null);
        }


	// DIBUJO
        /** initComponents: Metodo que dibuja toda la GUI de JDAccesoPers
	 *
	 * @param   void
	 * @return  void
	 */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        JLDNI = new javax.swing.JLabel();
        JSPPersonal = new javax.swing.JScrollPane();
        JTPersonal = new javax.swing.JTable();
        JBAceptar = new javax.swing.JButton();
        JTFBuscar = new javax.swing.JTextField();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        setTitle("Personal");

        JTPersonal.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {

            },
            new String [] {
                "DNI", "Primer apellido", "Segundo apellido", "Nombre"
            }
        ) {
            Class[] types = new Class [] {
                java.lang.String.class, java.lang.String.class, java.lang.String.class, java.lang.String.class
            };
            boolean[] canEdit = new boolean [] {
                false, false, false, false
            };

            public Class getColumnClass(int columnIndex) {
                return types [columnIndex];
            }

            public boolean isCellEditable(int rowIndex, int columnIndex) {
                return canEdit [columnIndex];
            }
        });
        JSPPersonal.setViewportView(JTPersonal);
        JTPersonal.getAccessibleContext().setAccessibleName("JTPersonal");

        JBAceptar.setIcon(new javax.swing.ImageIcon(getClass().getResource("/GUI/Icons/accept.png"))); // NOI18N
        JBAceptar.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                JBAceptarMouseClicked(evt);
            }
        });
        JBAceptar.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                JBAceptarActionPerformed(evt);
            }
        });

        JTFBuscar.setForeground(new java.awt.Color(204, 204, 204));
        JTFBuscar.setText("Buscar ...");
        JTFBuscar.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                JTFBuscarMouseClicked(evt);
            }
        });
        JTFBuscar.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyReleased(java.awt.event.KeyEvent evt) {
                JTFBuscarKeyReleased(evt);
            }
        });

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(layout.createSequentialGroup()
                        .addGap(624, 624, 624)
                        .addComponent(JLDNI))
                    .addComponent(JSPPersonal, javax.swing.GroupLayout.DEFAULT_SIZE, 624, Short.MAX_VALUE)
                    .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                        .addComponent(JTFBuscar, javax.swing.GroupLayout.PREFERRED_SIZE, 180, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 395, Short.MAX_VALUE)
                        .addComponent(JBAceptar)))
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addComponent(JLDNI)
                    .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                        .addComponent(JBAceptar)
                        .addComponent(JTFBuscar, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(JSPPersonal, javax.swing.GroupLayout.PREFERRED_SIZE, 184, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        JLDNI.getAccessibleContext().setAccessibleName("JLDNI");
        JSPPersonal.getAccessibleContext().setAccessibleName("JSPPersonal");
        JBAceptar.getAccessibleContext().setAccessibleName("JBAceptar");
        JTFBuscar.getAccessibleContext().setAccessibleName("JTFBuscar");

        pack();
    }// </editor-fold>//GEN-END:initComponents


 	// INICIALIZACION
        /** iniciarDatos: Metodo que inicializa todos los datos de los componentes de la interfaz grafica
         *
         * @param   void
         * @return  void
         */
        private void iniciarDatos()
        {
            try
            {
                    // Creamos el objeto de tipo Personal
                    Personal pp = new Personal();

                    // Obtenemos el filtro
                    String filtro = (JTFBuscar.getText().equals("Buscar ...") ? "" : JTFBuscar.getText());

                    // Obtenemos los datos de todo el personal del centro
                    ResultSet rs = pp.obtenerPersonalCentro(filtro);
                    // Refrescamos la tabla de personal
                    UGUI.rellenarTabla(JTPersonal,rs);
                    // Cerramos la conexion
                    pp.UBD.cerrarConexion();
            }
            catch (Exception e)
            {
                JOptionPane.showMessageDialog(this,"No ha sido posible mostrar el personal.","ERROR",JOptionPane.ERROR_MESSAGE);
            }
        }


    	// EVENTOS
    private void JBAceptarMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_JBAceptarMouseClicked
        // Escondemos el JDialog
        this.setVisible(false);
    }//GEN-LAST:event_JBAceptarMouseClicked

    private void JTFBuscarKeyReleased(java.awt.event.KeyEvent evt) {//GEN-FIRST:event_JTFBuscarKeyReleased
        // Refrescamos el personal en funcion del filtro escrito hasta el momento
        iniciarDatos();
    }//GEN-LAST:event_JTFBuscarKeyReleased

    private void JBAceptarActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_JBAceptarActionPerformed
        // Establecemos pulsarExit a false
        this.pulsarExit = false;
    }//GEN-LAST:event_JBAceptarActionPerformed

    private void JTFBuscarMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_JTFBuscarMouseClicked
        // Eliminamos el texto y ponemos la letra a color negro
        JTFBuscar.setText("");
        JTFBuscar.setForeground(Color.BLACK);
    }//GEN-LAST:event_JTFBuscarMouseClicked


	// FUNCIONALIDAD
        /** getDNI: Metodo que obtiene el DNI seleccionado de la JTable
	 *
	 * @param   void
	 * @return  String      DNI     DNI seleccionado de la JTable
	 */
        public String getDNI()
        {
            // Obtenemos la fila seleccionada
            int filSelec = JTPersonal.getSelectedRow();

            // Si existe alguna fila seleccionada devolvemos el DNI, si no devolvemos null
            if (filSelec != -1)     return (String) JTPersonal.getModel().getValueAt(filSelec,0);
            else                    return null;
        }

        /** getPulsarExit: Metodo que obtiene el valor del atributo pulsarExit, que denota si se ha salido pulsando Exit [x]
	 *
	 * @param   void
	 * @return  boolean     pulsarExit      Denota si se ha salido del JDialog pulsando Exit [x]
	 */
        public boolean getPulsarExit()      {return pulsarExit;}



	// MAIN
        /** main: Metodo principal ejecutable de la clase, encargado de desplegar el JDialog
	 *
	 * @param   String args[]
	 * @return  void
	 */
        public static void main(String args[])
        {
            java.awt.EventQueue.invokeLater(new Runnable()
            {
                public void run()
                {
                    JDAccesoPers dialog = new JDAccesoPers(new javax.swing.JFrame(), true);
                    dialog.addWindowListener(new java.awt.event.WindowAdapter() { public void windowClosing(java.awt.event.WindowEvent e) { System.exit(0); } });
                    dialog.setVisible(true);
                }
            });
        }


    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton JBAceptar;
    private javax.swing.JLabel JLDNI;
    private javax.swing.JScrollPane JSPPersonal;
    private javax.swing.JTextField JTFBuscar;
    private javax.swing.JTable JTPersonal;
    // End of variables declaration//GEN-END:variables
}
