// PAQUETE
package GUI.UIs;

// IMPORTACIONES
import API.Tablas.Cuenta;
import javax.swing.JOptionPane;



/** CLASE JDCUENTA:  Clase que representa el JDialog con el que el usuario puede configurar su cuenta a su gusto
 *
 * @author  Napal Basterrica, Hector
 * @version 1.0
 *
 */
public class JDCuenta extends javax.swing.JDialog
{
	// ATRIBUTOS -----------------------------------------------------------
        /** Usuario:                        Usuario a manejar en este JDialog */
        private static String               Usuario;



	// METODOS -------------------------------------------------------------
	// CONSTRUCTORES
	/** Constructor: Constructor de clase que crea el objeto JDCuenta con los valores pasados parametricamente
         *
         * @param   Frame       parente     Frame padre del JDialog
         * @param   modal       modal       Denota si el JDialog debe ser modal o no
         * @param   String      Usuario     Usuario a manejar
         * @return  JDialog     JDCuenta    Objeto de tipo JDCuenta
         */
        public JDCuenta(java.awt.Frame parent, boolean modal, String Usuario)
        {
            // Llamamos al constructor base
            super(parent, modal);
            // Asignamos los valores a las variables
            this.Usuario = Usuario;
            // Dibujamos todos los componentes
            initComponents();
            // Iniciamos todos los datos necesarios del JDialog
            iniciarDatos();
        }


	// DIBUJO
        /** initComponents: Metodo que dibuja toda la GUI de JDCuenta
	 *
	 * @param   void
	 * @return  void
	 */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        JPDatosCuenta = new javax.swing.JPanel();
        JPPass = new javax.swing.JPanel();
        JLNuevoPass = new javax.swing.JLabel();
        JLNuevoPassR = new javax.swing.JLabel();
        JPFNuevoPass = new javax.swing.JPasswordField();
        JPFNuevoPassR = new javax.swing.JPasswordField();
        JPUsuario = new javax.swing.JPanel();
        JLNuevoUsuario = new javax.swing.JLabel();
        JTFNuevoUsuario = new javax.swing.JTextField();
        JBModificarCuenta = new javax.swing.JButton();
        JPDatosC = new javax.swing.JPanel();
        JTFUsuario = new javax.swing.JTextField();
        JPFPass = new javax.swing.JPasswordField();
        JBModificarUsuario = new javax.swing.JButton();
        JBModificarPass = new javax.swing.JButton();
        JPAutent = new javax.swing.JPanel();
        JLPassActual = new javax.swing.JLabel();
        JPFPassActual = new javax.swing.JPasswordField();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        setTitle("Cuenta");

        JPDatosCuenta.setBorder(javax.swing.BorderFactory.createTitledBorder("Nuevos datos"));

        JLNuevoPass.setText("Contraseña");

        JLNuevoPassR.setText("Reescribe la contraseña");

        javax.swing.GroupLayout JPPassLayout = new javax.swing.GroupLayout(JPPass);
        JPPass.setLayout(JPPassLayout);
        JPPassLayout.setHorizontalGroup(
            JPPassLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(JPPassLayout.createSequentialGroup()
                .addContainerGap()
                .addGroup(JPPassLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(JLNuevoPass)
                    .addComponent(JLNuevoPassR))
                .addGap(18, 18, 18)
                .addGroup(JPPassLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                    .addComponent(JPFNuevoPassR)
                    .addComponent(JPFNuevoPass, javax.swing.GroupLayout.DEFAULT_SIZE, 157, Short.MAX_VALUE))
                .addContainerGap(30, Short.MAX_VALUE))
        );
        JPPassLayout.setVerticalGroup(
            JPPassLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(JPPassLayout.createSequentialGroup()
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addGroup(JPPassLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(JLNuevoPass)
                    .addComponent(JPFNuevoPass, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(JPPassLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(JLNuevoPassR)
                    .addComponent(JPFNuevoPassR, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)))
        );

        JLNuevoPass.getAccessibleContext().setAccessibleName("JLNuevoPass");
        JLNuevoPassR.getAccessibleContext().setAccessibleName("JLNuevoPassR");
        JPFNuevoPass.getAccessibleContext().setAccessibleName("JPFNuevoPass");
        JPFNuevoPassR.getAccessibleContext().setAccessibleName("JPFNuevoPassR");

        JLNuevoUsuario.setText("Usuario");

        javax.swing.GroupLayout JPUsuarioLayout = new javax.swing.GroupLayout(JPUsuario);
        JPUsuario.setLayout(JPUsuarioLayout);
        JPUsuarioLayout.setHorizontalGroup(
            JPUsuarioLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(JPUsuarioLayout.createSequentialGroup()
                .addGap(10, 10, 10)
                .addComponent(JLNuevoUsuario)
                .addGap(117, 117, 117)
                .addComponent(JTFNuevoUsuario, javax.swing.GroupLayout.PREFERRED_SIZE, 156, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(20, Short.MAX_VALUE))
        );
        JPUsuarioLayout.setVerticalGroup(
            JPUsuarioLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(JPUsuarioLayout.createSequentialGroup()
                .addGap(14, 14, 14)
                .addGroup(JPUsuarioLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(JLNuevoUsuario)
                    .addComponent(JTFNuevoUsuario, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        JLNuevoUsuario.getAccessibleContext().setAccessibleName("JLNuevoUsuario");
        JTFNuevoUsuario.getAccessibleContext().setAccessibleName("JTFNuevoUsuario");

        JBModificarCuenta.setIcon(new javax.swing.ImageIcon(getClass().getResource("/GUI/Icons/accept.png"))); // NOI18N
        JBModificarCuenta.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                JBModificarCuentaActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout JPDatosCuentaLayout = new javax.swing.GroupLayout(JPDatosCuenta);
        JPDatosCuenta.setLayout(JPDatosCuentaLayout);
        JPDatosCuentaLayout.setHorizontalGroup(
            JPDatosCuentaLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(JPDatosCuentaLayout.createSequentialGroup()
                .addContainerGap()
                .addGroup(JPDatosCuentaLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(JPDatosCuentaLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                        .addGroup(JPDatosCuentaLayout.createSequentialGroup()
                            .addComponent(JPUsuario, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addContainerGap(29, Short.MAX_VALUE))
                        .addGroup(JPDatosCuentaLayout.createSequentialGroup()
                            .addComponent(JPPass, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addContainerGap()))
                    .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, JPDatosCuentaLayout.createSequentialGroup()
                        .addComponent(JBModificarCuenta)
                        .addGap(116, 116, 116))))
        );
        JPDatosCuentaLayout.setVerticalGroup(
            JPDatosCuentaLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(JPDatosCuentaLayout.createSequentialGroup()
                .addComponent(JPUsuario, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(JPPass, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(JBModificarCuenta)
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        JPPass.getAccessibleContext().setAccessibleName("JPPass");
        JPUsuario.getAccessibleContext().setAccessibleName("JPUsuario");
        JBModificarCuenta.getAccessibleContext().setAccessibleName("JBModificarCuenta");

        JPDatosC.setBorder(javax.swing.BorderFactory.createTitledBorder("Usuario y contraseña"));

        JTFUsuario.setEditable(false);
        JTFUsuario.setBorder(javax.swing.BorderFactory.createEtchedBorder());

        JPFPass.setEditable(false);
        JPFPass.setBorder(javax.swing.BorderFactory.createEtchedBorder());

        JBModificarUsuario.setIcon(new javax.swing.ImageIcon(getClass().getResource("/GUI/Icons/arrow_refresh.png"))); // NOI18N
        JBModificarUsuario.setActionCommand("jButton1");
        JBModificarUsuario.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                JBModificarUsuarioActionPerformed(evt);
            }
        });

        JBModificarPass.setIcon(new javax.swing.ImageIcon(getClass().getResource("/GUI/Icons/arrow_refresh.png"))); // NOI18N
        JBModificarPass.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                JBModificarPassActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout JPDatosCLayout = new javax.swing.GroupLayout(JPDatosC);
        JPDatosC.setLayout(JPDatosCLayout);
        JPDatosCLayout.setHorizontalGroup(
            JPDatosCLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(JPDatosCLayout.createSequentialGroup()
                .addContainerGap()
                .addGroup(JPDatosCLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(JPDatosCLayout.createSequentialGroup()
                        .addComponent(JTFUsuario, javax.swing.GroupLayout.PREFERRED_SIZE, 149, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(JBModificarUsuario))
                    .addGroup(JPDatosCLayout.createSequentialGroup()
                        .addComponent(JPFPass, javax.swing.GroupLayout.PREFERRED_SIZE, 149, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(JBModificarPass)))
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );
        JPDatosCLayout.setVerticalGroup(
            JPDatosCLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(JPDatosCLayout.createSequentialGroup()
                .addContainerGap()
                .addGroup(JPDatosCLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addComponent(JTFUsuario, javax.swing.GroupLayout.PREFERRED_SIZE, 20, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(JBModificarUsuario))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(JPDatosCLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(JPFPass, javax.swing.GroupLayout.PREFERRED_SIZE, 20, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(JBModificarPass))
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        JTFUsuario.getAccessibleContext().setAccessibleName("JTFUsuario");
        JPFPass.getAccessibleContext().setAccessibleName("JPFPass");
        JBModificarUsuario.getAccessibleContext().setAccessibleName("JBModificarUsuario");
        JBModificarPass.getAccessibleContext().setAccessibleName("JBModificarPass");

        JPAutent.setBorder(javax.swing.BorderFactory.createTitledBorder("Autenticación"));

        JLPassActual.setText("Contraseña actual");

        javax.swing.GroupLayout JPAutentLayout = new javax.swing.GroupLayout(JPAutent);
        JPAutent.setLayout(JPAutentLayout);
        JPAutentLayout.setHorizontalGroup(
            JPAutentLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(JPAutentLayout.createSequentialGroup()
                .addGap(20, 20, 20)
                .addComponent(JLPassActual)
                .addGap(58, 58, 58)
                .addComponent(JPFPassActual, javax.swing.GroupLayout.PREFERRED_SIZE, 156, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(56, Short.MAX_VALUE))
        );
        JPAutentLayout.setVerticalGroup(
            JPAutentLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(JPAutentLayout.createSequentialGroup()
                .addGroup(JPAutentLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(JLPassActual)
                    .addComponent(JPFPassActual, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addContainerGap(6, Short.MAX_VALUE))
        );

        JLPassActual.getAccessibleContext().setAccessibleName("JLPassActual");
        JPFPassActual.getAccessibleContext().setAccessibleName("JPFPassActual");

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addComponent(JPDatosCuenta, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addGroup(javax.swing.GroupLayout.Alignment.LEADING, layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                        .addComponent(JPDatosC, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addComponent(JPAutent, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)))
                .addContainerGap(20, Short.MAX_VALUE))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(JPDatosC, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(JPAutent, javax.swing.GroupLayout.PREFERRED_SIZE, 53, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(JPDatosCuenta, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(19, Short.MAX_VALUE))
        );

        JPDatosC.getAccessibleContext().setAccessibleName("JPDatosC");
        JPAutent.getAccessibleContext().setAccessibleName("JPAutent");

        pack();
    }// </editor-fold>//GEN-END:initComponents


 	// INICIALIZACION
        /** iniciarDatos: Metodo que inicializa todos los datos de los componentes de la interfaz grafica
         *
         * @param   void
         * @return  void
         */
        private void iniciarDatos()
        {
            try
            {
                // Rellenamos el nombre de usuario y contraseña
                JTFUsuario.setText(Usuario);
                JPFPass.setText(new Cuenta(Usuario).getPass());

                // Escondemos los JPanels de modificaciones
                JPUsuario.setVisible(false);
                JPPass.setVisible(false);
                JPDatosCuenta.setVisible(false);
                JPAutent.setVisible(false);
            }
            catch (Exception e)
            {
                JOptionPane.showMessageDialog(this,"No ha sido posible mostrar la información de la cuenta.","ERROR",JOptionPane.ERROR_MESSAGE);
                e.printStackTrace();
            }
        }


    	// EVENTOS
    private void JBModificarUsuarioActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_JBModificarUsuarioActionPerformed
        // Borramos los campos necesarios y mostramos los paneles de modificacion de cuenta
        JPFPassActual.setText("");
        JPAutent.setVisible(true);
        JTFNuevoUsuario.setText("");
        JPUsuario.setVisible(true);
        JPPass.setVisible(false);
        JPDatosCuenta.setVisible(true);
    }//GEN-LAST:event_JBModificarUsuarioActionPerformed

    private void JBModificarCuentaActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_JBModificarCuentaActionPerformed
        try
        {

            // Chequeamos la autenticidad del usuario que realiza la modificación
            Cuenta cuenta_old = new Cuenta (JTFUsuario.getText());
            char passArray[] = JPFPassActual.getPassword();
            for (int i = 0; i < passArray.length; i++)  { char c = passArray[i]; }
            String Pass = new String(passArray);

            // Si el nombre de usuario y contraseña casan -> Modificamos lo que corresponda
            if (!cuenta_old.checkPass(Pass).equals("Inexistente"))
            {
                // Avisamos de que vamos a modificar la cuenta
                int seleccion = JOptionPane.showConfirmDialog(this,"Atención, se va a proceder a modificar los datos de la cuenta.\n" +
                        "¿Desea llevar a cabo esta operación?","ATENCIÓN",JOptionPane.YES_NO_OPTION);

                // Si se acepta la operacion -> Modificamos la cuenta
                if (seleccion == 0)
                {
                    // Creamos la nueva cuenta
                    Cuenta cuenta_new = new Cuenta(Usuario);
                    
                    // Si lo que se modifica es el nombre de usuario
                    if (JPUsuario.isShowing())
                    {
                        // Asignamos el nuevo usuario a la cuenta
                        cuenta_new.setUsuario(JTFNuevoUsuario.getText());

                        // Modificamos la cuenta vieja por la nueva
                        cuenta_old.updateCuentaBD(cuenta_new);

                        // Modificamos JTFUsuario
                        JTFUsuario.setText(cuenta_new.getUsuario());
                        Usuario = cuenta_new.getUsuario();

                        // Escondemos los JPanels
                        JPAutent.setVisible(false);
                        JPUsuario.setVisible(false);
                        JPDatosCuenta.setVisible(false);

                        // Advertimos de que el usuario de la cuenta ha sido modificado correctamente
                        JOptionPane.showMessageDialog(this,"El usuario de la cuenta ha sido modificado correctamente.","AVISO",JOptionPane.INFORMATION_MESSAGE);
                    }
                    // Si lo que se modifica es la contraseña
                    else
                    {
                        // Recogemos los nuevos passwords
                        passArray = JPFNuevoPass.getPassword();
                        for (int i = 0; i < passArray.length; i++)  { char c = passArray[i]; }
                        String NuevoPass = new String(passArray);
                        passArray = JPFNuevoPassR.getPassword();
                        for (int i = 0; i < passArray.length; i++)  { char c = passArray[i]; }
                        String NuevoPassR = new String(passArray);

                        // Si ambos coinciden -> Actualizamos la contraseña de la cuenta
                        if (NuevoPass.equals(NuevoPassR))
                        {
                            // Asignamos el nuevo pass a la cuenta
                            cuenta_new.setPass(NuevoPass);

                            // Modificamos la cuenta vieja por la nueva
                            cuenta_old.updateCuentaBD(cuenta_new);

                            // Modificamos JPFPass
                            JPFPass.setText(cuenta_new.getPass());

                            // Escondemos los JPanels
                            JPAutent.setVisible(false);
                            JPPass.setVisible(false);
                            JPDatosCuenta.setVisible(false);

                            // Advertimos de que la contraseña de la cuenta ha sido modificada correctamente
                            JOptionPane.showMessageDialog(this,"La contraseña de la cuenta ha sido modificada correctamente.","AVISO",JOptionPane.INFORMATION_MESSAGE);
                        }
                        // Si no coinciden -> Avisamos del error
                        else
                        {
                            JOptionPane.showMessageDialog(this,"Los campos de la nueva contraseña no son iguales.\nPor favor, vuelva a introducir ambos campos de nuevo.","ERROR",JOptionPane.ERROR_MESSAGE);
                        }
                    }
                }
            }
            // Si usuario y password no casan -> Avisamos del error
            else
            {
                JOptionPane.showMessageDialog(this,"Contraseña no válida.","ERROR",JOptionPane.ERROR_MESSAGE);
            }
        }
        catch (Exception e)
        {
            JOptionPane.showMessageDialog(this,"No ha sido posible modificar la cuenta.","ERROR",JOptionPane.ERROR_MESSAGE);
        }
    }//GEN-LAST:event_JBModificarCuentaActionPerformed

    private void JBModificarPassActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_JBModificarPassActionPerformed
        // Borramos los campos necesarios y mostramos los paneles de modificacion de cuenta
        JPFPassActual.setText("");
        JPAutent.setVisible(true);
        JPUsuario.setVisible(false);
        JPFNuevoPass.setText("");
        JPFNuevoPassR.setText("");
        JPPass.setVisible(true);
        JPDatosCuenta.setVisible(true);
    }//GEN-LAST:event_JBModificarPassActionPerformed


    
	// MAIN
        /** main: Metodo principal ejecutable de la clase, encargado de desplegar el JDialog
	 *
	 * @param   String args[]
	 * @return  void
	 */
        public static void main(String args[])
        {
            java.awt.EventQueue.invokeLater(new Runnable()
            {
                public void run()
                {
                    JDCuenta dialog = new JDCuenta(new javax.swing.JFrame(), true, Usuario);
                    dialog.addWindowListener(new java.awt.event.WindowAdapter() { public void windowClosing(java.awt.event.WindowEvent e) { System.exit(0); } });
                    dialog.setVisible(true);
                }
            });
        }

        
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton JBModificarCuenta;
    private javax.swing.JButton JBModificarPass;
    private javax.swing.JButton JBModificarUsuario;
    private javax.swing.JLabel JLNuevoPass;
    private javax.swing.JLabel JLNuevoPassR;
    private javax.swing.JLabel JLNuevoUsuario;
    private javax.swing.JLabel JLPassActual;
    private javax.swing.JPanel JPAutent;
    private javax.swing.JPanel JPDatosC;
    private javax.swing.JPanel JPDatosCuenta;
    private javax.swing.JPasswordField JPFNuevoPass;
    private javax.swing.JPasswordField JPFNuevoPassR;
    private javax.swing.JPasswordField JPFPass;
    private javax.swing.JPasswordField JPFPassActual;
    private javax.swing.JPanel JPPass;
    private javax.swing.JPanel JPUsuario;
    private javax.swing.JTextField JTFNuevoUsuario;
    private javax.swing.JTextField JTFUsuario;
    // End of variables declaration//GEN-END:variables
}
