-- *********************************************************************************************************************
-- ******** DISPARADORES																					************
-- *********************************************************************************************************************

	-- Tabla 'Tarjeta'
	CREATE TRIGGER actu_tarj
		AFTER UPDATE ON Tarjeta FOR EACH ROW
			BEGIN
				DELETE FROM Color WHERE Cod_Color NOT IN (SELECT Cod_Color FROM Tarjeta WHERE F_Baja_T IS NULL);
				DELETE FROM Nivel WHERE Cod_Niv NOT IN (SELECT Cod_Niv FROM Color WHERE F_Baja_C IS NULL);
			END; |
	
	CREATE TRIGGER borr_tarj
		AFTER DELETE ON Tarjeta FOR EACH ROW
			BEGIN
				DELETE FROM Color WHERE Cod_Color NOT IN (SELECT Cod_Color FROM Tarjeta WHERE F_Baja_T IS NULL);
				DELETE FROM Nivel WHERE Cod_Niv NOT IN (SELECT Cod_Niv FROM Color WHERE F_Baja_C IS NULL);
			END; |

			
	-- Tabla 'Zona'
	CREATE TRIGGER borr_zona
		AFTER DELETE ON Zona FOR EACH ROW
			BEGIN
				DELETE FROM Llavero WHERE (Cod_Llavero,F_Alta_Ll) NOT IN (SELECT DISTINCT Cod_Llavero,F_Alta_Ll FROM Composicion_Llavero);
				DELETE FROM Almacen WHERE Cod_Alm NOT IN (SELECT DISTINCT Cod_Alm FROM Almacen_Llave UNION SELECT DISTINCT Cod_Alm FROM Almacen_Llavero);		
			END; |	

			
	-- Tabla 'Departamento'
	CREATE TRIGGER borr_dep
		AFTER DELETE ON Departamento FOR EACH ROW
			BEGIN
				DELETE FROM Empresa WHERE Cod_Emp NOT IN (SELECT DISTINCT Cod_Emp FROM Departamento);
				DELETE FROM Personal WHERE DNI NOT IN (	SELECT DISTINCT DNI FROM Periodico
																UNION
														SELECT DISTINCT DNI FROM Contacto
																UNION
														SELECT DISTINCT DNI FROM Ocasional
																UNION
														SELECT DISTINCT DNI FROM Residente);
				DELETE FROM Cargo WHERE Cod_Cargo NOT IN (SELECT DISTINCT Cod_Cargo FROM Contacto);
			END; |
	
	
	-- Tabla 'Contacto'
	CREATE TRIGGER borr_contac
		AFTER DELETE ON Contacto FOR EACH ROW
			BEGIN
				DELETE FROM Cargo WHERE Cod_Cargo NOT IN (SELECT DISTINCT Cod_Cargo FROM Contacto);
				DELETE FROM Personal WHERE DNI=OLD.DNI AND DNI NOT IN (SELECT DISTINCT DNI FROM Contacto);
			END; |
			
-- *********************************************************************************************************************
-- *********************************************************************************************************************